e63d804f (HEAD, tag: v5.20231029.0, origin/v5.x-branch) limine: Fix two other small typos in PROTOCOL.md
cad3c72f config: Fix bug where macro definitions were not skipped over properly when parsing
7cd46f3d Merge pull request #314 from iProgramMC/fix-typo-in-protocol-1
f4051f49 limine: Fix a small typo error in PROTOCOL.md
a5051f92 (tag: v5.20231028.0) build: Changes to comply more with the GNU build system - adds ChangeLog
ec564407 (tag: v5.20231024.0) docs: Update example Limine version in README to 5.20231024.0
a0127f9f pmm: Add MEMMAP_MAX macro and use it instead of hardcoding 256
e49865a4 lib/time: EFI: Return time of 0 if GetTime() unsupported
2bba7263 lib/gterm: Try to initialize all 32-bpp framebuffers
45b39285 pmm: Ignore allow_high_allocs on non x86-64 architectures
a795dc19 build: Backport misc autoconf/pkgconf improvements
c1860c8d limine/ioapic: Change spec to avoid masking IOAPIC RTEs unless Fixed or Lowest Priority
49cfba85 build: Misc minor QOL configure.ac/GNUmakefile.in improvements
b348bb75 (tag: v5.20231006.0) docs: Update example Limine version in README to 5.20231006.0
c1f5b211 misc: Remove unnecessary ifdefs added in previous commits
b474b6ba misc: Only allocate memory and modules above 4GiB on 64-bit platforms
5323bce1 pmm: Allow allocations above 4GiB and use them in freadall()
1bcbf817 (tag: v5.20230928.2) docs: Update example Limine version in README to 5.20230928.2
f81b9d2d build: Fix makefile target dependencies bug introduced in a0c2f95
d0a1285f (tag: v5.20230928.1) docs: Update example Limine version in README to 5.20230928.1
a0c2f95a build: Fix bug introduced in 7885f260 due to a misunderstanding of an objcopy flag
d421ebcb (tag: v5.20230928.0) docs: Update example Limine version in README to 5.20230928.0
7117b85c build: Fix indentation issue in common/GNUmakefile
3a81c3e1 build: ldscripts: .reloc -> .dummy_reloc
a0997a59 build: Fix race conditions introduced in 22d45a54283d7f58f3ed7452278005baf6323f53
212dbd32 misc: Add .note.GNU-stack where it was still missing
a55f68b3 smp: riscv64: Replace .insn directive with .4byte
a83dafe6 misc: Add section .note.GNU-stack to assembly files
afdc5563 time: Change signature of get_jdn() to use int types
bfc518cc (tag: v5.20230924.0) docs: Update example Limine version in README to 5.20230924.0
81c39fc0 elf: Panic if there are PHDRs with different perms sharing same page
87a88bf5 smp: Remove dead 32-bit trampoline code
3fde8f01 docs: PROTOCOL.md: Fix up layout of mappings table
50f4383f limine: Make explicit some implied padding in some structures
c7df84e2 test: riscv64: Fix issue with OVMF not working on latest QEMU
f1236373 menu: Fix padding issue introduced in e1d25f8
a36de776 (tag: v5.20230917.0) docs: Update example Limine version in README to 5.20230917.0
a0fb5a04 docs: PROTOCOL.md: Backport caching section from trunk
042a6e95 misc: Backports from trunk
c5c43cb0 misc: aarch64: Remove unused enter_in_current_el() function
5f7bcc0b riscv: Fix cherry-picking issue introduced in e3d65aa628edec447877d6e22debd225ac670fba
45958f71 misc: Consistently call x86-64 such, instead of x86_64
e9b55110 docs: PROTOCOL.md: Minor fixes
f4bfe128 riscv: skip `rv{32,64}` prefix when parsing extensions from isa strings
cdac49eb acpi: remove duplicate definition in sys/lapic.c
90b82dc4 riscv/vmm: use Svpbmt extension when available
e3d65aa6 riscv: refactor smp init
f33732a2 riscv: implement feature dectection
09c430f2 lib/libc: add misc utilities
2200161e acpi: move acpi structure defs to lib/acpi.h
f8bfe41e (tag: v5.20230911.0) test: Use -dumpmachine to find architecture instead of expecting -target
0f7ee056 misc/bios: Update and improve linker script and related files
b54c3fc9 protos/chainload: Fix bug that could result in bogus oom errors. Fixes #302
756dd235 decompressor: Mark .entry section with proper flags in entry.asm
09c87fea decompressor: Add rodata PHDR and section to ld script
916aa370 protos: chainload: Allocate memory for the null terminator in cmdline
0ebf0245 misc: Misc EFI linker script improvements and drop .sbat
8f789fc0 (tag: v5.20230909.0) docs: Update example Limine version in README to 5.20230909.0
b5cffbb6 misc: Improve UEFI linker scripts
9ff62c2a docs: README.md: Fix minor grammar mistake
68f82c3d stage1/gdt: Mark accessed flag in descriptors
2642249e docs: Remove references to shim as we don't directly support it
e6a67c80 x86/gdt: Mark accessed flag in descriptors
541dbd26 (tag: v5.20230830.0) docs: Update example Limine version in README to 5.20230830.0
e207c03f build: Drop -mabi=sysv for x86 for clang 16
57e4ae6e config: Disable editor by default if config b2sum present. Fixes #296
a30cad35 menu: Change menu arrow to use unicode big arrow
ac0d9465 gterm: Update font's big left and right arrows
f0b899b5 (tag: v5.20230819.0) docs: Update example Limine version in README to 5.20230819.0
4abedffb disk: BIOS: Skip drive if sector size is 0. Fixes #294
50dab6c2 smp: aarch64: Don't needlessly invalidate the data cache
ba5d63b8 elf: aarch64: Don't needlessly invalidate the data cache
573d0095 elf: elf64_load_section(): Return false early if sh_num == 0
27a32e41 disk: Add additional volume_index_i overflow guards
9a074530 exceptions: Change naming of exceptions in panic message
a248b557 (tag: v5.20230811.0) docs: Update example Limine version in README to 5.20230811.0
d66df6b3 limine: Do not return SMBIOS response if not present
1e9a42e7 test: General makefile updates
b8fff872 test: Use Flanterm
820d4751 menu: Add option to hide help text
82ea6d6a test/riscv: disable linker relaxation, specify ISA string and ABI
030242d6 (tag: v5.20230804.0) vmm/riscv: fix bug in `vmm_max_paging_mode()`
b64335f6 (tag: v5.20230801.0) docs: Update example Limine version in README to 5.20230801.0
50b8ab2c rv64: Misc relaxation related fixes
2d0752f6 (tag: v5.20230729.0) docs: Update example Limine version in README to 5.20230729.0
ff86be6b misc: Update test wallpaper and screenshot
2f1dac06 gterm: Change resolutions at which autoscaling is triggered
0ecb2ab8 menu: Center menu vertically
474fc105 gop: Readd preset mode storage
418f8d72 menu: Do not draw box around boot menu
722bde2c (tag: v5.20230728.0) menu: Adjust centering by 2 characters to the left
5bdb1bbf menu: Fix a couple of boot menu alignment issues
8f167bc2 menu: Initialise max_len if null regardless of shift
d73cd378 menu: Fix maybe uninitialised issue with cur_len var
478b6f38 menu: Fix NULL deref bug with shift variable
4b452e69 console: Add slide command
98f30bfd menu: Center boot menu
ba259760 Revert "build: Make limine-uefi-cd.bin 16MiB in size (use FAT16)"
9921af54 gterm: Autoscale font on higher resolutions
a2e50232 (tag: v5.20230726.0) limine: Adjust higher half offsets for AArch64
dc68fcaf limine: Use a higher-half pointer for the stack on AArch64
f365a466 misc: Minor updates to linker scripts
871a8053 build: Get rid of OBJCOPY2ELF_FLAGS since only IA-32/BIOS used it
49ecb6b5 build: Get rid of RISCV_CFLAGS variable as it is now unnecessary
997e2c75 ci: Remove openssh dependency no longer required for release
bc1896c5 riscv64: Do not use global pointer register
e261a96f docs/protocol: Fix typo and mandate ra and gp registers to be 0 for rv64
1f82dd89 host/limine: Fix typo
93942a33 (tag: v5.20230709.0) docs: Update example Limine version in README to 5.20230709.0
b72d0335 elf: elf64_load(): Remove accidentally left in debug code
11f50a6a part: Require keypresses between entry displays in list_volumes()
79e50a82 misc: Use assembly for memory functions on x86
17e26c8c elf: Fix potential uninitialised usage of bss_size
9333f1ca limine/elf: Optimise not to scan .bss for requests
99d671ec (tag: v5.20230620.0) build: Drop -Wno-deprecated-declarations flag
7882d89b limine: Drop 5-level paging request support
1ad6d601 limine: Drop terminal request support
2ac43a32 asm: Add missing section directives
2d6a1e45 console: Add firmware type command
d08ea721 limine.c: Add copyright and license information to version command
6e419382 gensyms: Filter out non-function symbols
67fd1a8d docs: Update example Limine version in README to 4.20230615.0
66268f7d pmm: Use fixed value of 1024 for recl entries count
cb14f44e pmm: Fix change-memmap-in-use bug
910a0d84 vmm: Fix page_sizes values and move declaration to top
2da0a080 build: Make limine-uefi-cd.bin 16MiB in size (use FAT16)
670b635a config: Add and document ARCH built-in macro
bc8188e2 misc: limine.sys -> limine-bios.sys
38ccb76c misc: limine-hdd.bin -> limine-bios-hdd.bin
7b128480 build: Fix permissions of output files in makefile instead of release recipe
34a2e85c misc: Add missing EFI executables install commands to host Makefile
ece02695 misc: limine-cd.bin -> limine-bios-cd.bin
45fd1ac0 test: Misc updates to the linker script
264decd0 misc: limine-cd-efi.bin -> limine-uefi-cd.bin
d0b9bbdc misc: limine-pxe.bin -> limine-bios-pxe.bin
1c5fde5d misc: Add BOOTRISCV64.EFI to permissions fix list
a069e220 docs: BOOT{IA32,X64,AA64}.EFI -> BOOT*.EFI
b764792c docs: Mention creating the ESP tree in ISOHYBRID partition
a9e6e009 docs: Add donations link
2b154138 misc: Updates for new limine-efi
cde874fe misc: Updates for new flanterm
a627c732 docs: Update example Limine version in README to 4.20230606.0
b78309b4 misc: Remove tinf from tree, pull at bootstrap time
666c5dfc riscv64: Update location of __global_pointer$
13042bd2 build/riscv64: libgcc-riscv64 -> libgcc-riscv64-softfloat
f6946a7f test: Use retrage.github.io EDK2 nightly builds for all ports
74a6b8e1 protos/linux: Do not zero EFI memmap size on IA-32 EFI
705719a2 docs/readme: Adjust stb_image.h link to point to dev branch
e205d51c docs: Add Limine pronounciation link to README.md
fa7b2409 Merge pull request #276 from xvanc/trunk
1f01ddfc limine: scale the maximum KASLR offset based on the address space size
9274ee65 Initial riscv64 port (#274)
e91196d4 test: Fix copying mistake (typo)
bee1d50c Merge pull request #275 from blanham/netboot_fix_when_no_block_io
fe083d37 Fix netboot in configs where BLOCK_IO does not exist
dce1c31a docs: Update example Limine version in README to 4.20230530.0
f26b651e disk/efi: Do not use DISK_IO protocol and fix buffer reuse bug
679fdd43 misc: Use C instead of asm for mem*() family of functions
4190710d docs: Update example Limine version in README to 4.20230529.0
9079f300 ci: Fix permissions of certain files in binary branch
eac03c8c build/uefi: Remove now-useless -DGNU_EFI_USE_MS_ABI flag
0125dcd6 build/uefi: Pass -fshort-wchar to CC
84438648 docs: Update example Limine version in README
71b175b7 stb_image: Track dev branch
153412f5 host: Perform compile-time endian check if supported
79890645 elf: Improve detection of relocatable ELFs
836d1c20 docs: Update example Limine version in README
2c11fb33 stb_image: Update to commit with zlib EOF bug fixed
73462a51 Revert "compress/gz: Add hack to allow macOS compressed GZs to load with stbi"
f618eb26 Revert "misc: Revert back to using tinf for all GZ decompression"
e9186e18 Revert "uri: Backport pre-tinf-removal variable assignments"
35808c59 build: Remove some empty lines in dist make target
717c60cd Merge pull request #271 from blanham/multiboot1_fix_elf32_section_loading
e0c3e6bd multiboot1: also fix elf32 section loading
df34599f Merge pull request #270 from blanham/multiboot2_fix_elf32_section_loading
fdcb9a92 multiboot2: fix 32 bit elf section loading
1a488885 hgen: Add extra sed command for handling Solaris's od
8dd7973e pxe: Add and use constant PXE ACK packet size and fix BIOS PXE ACK struct
36846549 menu: Do not initialise textmode terminal if QUIET=yes. Addresses #269
172060e2 bootstrap: Add BOOTSTRAP_NO_SHALLOW_CLONES support
d7da6d63 Merge pull request #267 from blanham/add_multiboot2_network_tag
2362f1a7 Implement Multiboot2 network tag
2a26d903 Merge pull request #265 from blanham/fix_pxe_proxy_boot
64a0c607 Fix PXE BIOS boot when using a proxy DHCP server
73b126e0 build: Sanitise autoconf substitutions with gmake variables
c41e3969 build: Pass proper warning flags to nasm
b991fb93 docs: Document TEXTMODE config for multiboot 1 and 2
e57050d9 multiboot1: Support TEXTMODE config as with Linux/mb2 protocols
93ae0e9a textmode: Actually disable term hooking on non-managed initialisation
36139971 Merge pull request #263 from klange/mb2-textmode
eae24e64 Merge pull request #262 from klange/mb2-ignore-optional
2da6225f multiboot2: ignore unsupported tags if they are marked optional
a3f84fc4 multiboot2: Support TEXTMODE config as with linux
240d9688 multiboot2: Fix lack of argument to panic format string
7ad44493 host: Condense various host utilities into a single executable
eba0183b build: Reorganise warning flags
ebd1953e build: Use uppercase PIE/PIC compilation flags
51452212 uri: Backport pre-tinf-removal variable assignments
3438b8d2 misc: Revert back to using tinf for all GZ decompression
e0f8d94d limine: Fix spurious deprecation warnings coming from limine.h
67d26318 limine: Add note about deprecation of terminal to PROTOCOL.md
b66184cf limine: Clarify ambiguity with response revision and internal modules
012605ad limine: Fix issue with internal modules and kernels in root dir
d0df21ab limine: Mark terminal as deprecated
01eeeb6e term: Drop in_bootloader for new Flanterm
77957133 misc: Updates for Flanterm rebrand
936240a3 limine-deploy: Check ferror() before using perror() on fread/fwrite fails
a2dd3449 limine: Fix framebuffer pointer in terminal struct being invalid without a framebuffer request
42027470 limine: Fix bug where internal modules are parsed with revision < 1
45ff0e2e limine: Document internal modules
d0ee1e7d limine: Support relative-to-kernel paths for internal modules
698ca1a6 limine: Honour LIMINE_INTERNAL_MODULE_REQUIRED flag
830251e6 limine: Load internal modules before config modules
d4334699 limine: Implement internal modules concept
5a53f91e build: Split test portion of root makefile to own file
0196abf2 build: Minor build system updates
2ea3f7e9 build: Minor build system updates
3bf159d8 compress: Rename modified tinfgzip wrapper to gzip
96633181 build: Remove useless unset commands from common GNUmakefile
c202cce7 build: Use DEFAULT_VAR for all overridable default makefile vars
813c1e6c Revert "build: bootstrap: Do not manually install install-sh"
fadb9a7c build: Misc updates for new freestanding-toolchain
7d6125d4 build: Fix up some makefile variable names
f71f506b build: configure: Change some variable names to be more friendly
08647f7d decompressor: Move tinf directory to decompressor directory
c7a7539d build: configure: Exit on freestanding-toolchain error
5f5c9886 build: bootstrap: Do not manually install install-sh
7dc04b42 build: Add and use PROG_ABSPATH autoconf macro
9009404a build: Updates for newer freestanding-toolchain
674f490f misc: bootstrap: Fix freestanding-toolchain presence check
b072a08f misc: Do not remove freestanding-toolchain from release tarball
8d61d0ab misc: Use freestanding-toolchain instead of cross-detect
d1e4b994 docs: LICENSE.md -> LICENSE
828e3790 chainload: LoadOptionsSize should be in bytes. Fixes #254
ca694756 protocol: Specify that kernel must be physically contiguous
246276a5 chainload: BIOS: do not rely on 0x7c00 being free
980c1224 vga_textmode: Minor cursor-related bug fixes
4ef529b4 misc: Load BIOS port at 0xf000 instead of 0x8000
5bc6fbca misc: Change example wallpaper
fc4e283a stb_image: Fix free/realloc wrappers to handle being passed NULL
0f4beb1b gterm: Fix NULL dereference bug when no wallpaper used
9d6c6495 gh: Remove issue templates
1dd75a18 compress/gz: Add hack to allow macOS compressed GZs to load with stbi
8bb12244 image: Use stbi_image_free() instead of freeing buffer ourselves
753bb820 stb_image: More proper implementation of malloc/free/realloc macros
5f84ade1 docs: Minor README.md formatting fix
959c4465 image: Use stb_image for image loading
11ef3bce build: Honour CROSS_CPPFLAGS
a786c26a build: Install markdown docs on install; distclean fix
8ee9dc1e build: Only install limine-deploy.1 man page if built
d17e220e docs: Add man pages for host executables
9bcad9d2 build: Very minor QOL fixes
b4649f88 docs: Update PHILOSOPHY.md to note reason for ext* driver inclusion
1e65ada4 Revert "fs: Drop ext* support"
c924d7b7 build: Misc quality-of-life fixes
ce7a5527 misc: Let freestanding-headers handle limits.h
c7f34478 menu: Fix issue introduced in 48053fd2 where TIMEOUT=0 would not show interface
48053fd2 misc: Fix bug on trunk where returns to menu from panic would crash
e9094896 vga_textmode: Unbreak on trunk
a3f814b5 uri/tinfgzip: Minor fixes and layering improvement
3ae87be5 uri: Fix minor use-after-free bug
9b073512 uri: Prevent memory leak when opening compressed files
82aec4b1 docs: Update PHILOSOPHY.md noting that ext2/3/4 has been dropped
143d3d85 stb/image: Comment out problematic functions
1099993b stb: Ignore some warnings coming from stb_image.h
71b3ae54 compress: Replace tinf's inflate implementation with stb_image's zlib
caaf4f94 fs: Drop ext* support
bcac8b62 build: Use separate STRIP program in host Makefile
d744fc8c build: Further fixes related to cd8188d8
ec34c86d build: Update for latest cross-detect
8b7dc549 build: Misc configure.ac improvements, install-strip fix ups
7e46840b build: Update for latest cross-detect
87bea2fe host/enroll-config: Bring up to standard with deploy
8d427d76 host/enroll-config: Fix buffer overflow
cd8188d8 build: Fix race condition in root GNUmakefile.in
fb4b02a4 docs: README.md: Document secure boot and config hash enrolling
8c7655ea docs: Misc README.md fixes and updates
c30afde0 config: Do not allow recovering from checksum mismatch panic
843be075 config: No longer allow continuing boot on checksum mismatches
8c7a9831 misc: Add support for enrolling config blake2b hash in executable
191ad51e docs: Add PHILOSOPHY.md
5c1b96b3 protocol: Update copyright date in limine.h
a7721872 term: Expose support for out-of-band output control
28dd8a10 file: Fix several bugs to do with handling of path field
2091aa9c Revert "Revert "Revert "ci: Build and check using Alpine instead of Arch"""
41d4b3af Merge pull request #246 from Qwinci/trunk
3dd0a6fb limine: Add UEFI PXE support based on @qookei's original patch with small changes.
ac1c5d1b efi/chainload: Support passing of command lines. Addresses #244
a085af55 misc: Update copyright for 2023
8caf7b5b Revert "Revert "ci: Build and check using Alpine instead of Arch""
a0d8c7b2 ci: Remove website upload portion of workflow
2ee93972 term: Compatibility with new terminal code
1aba6b3a lib/gterm: Remove now-useless full_refresh() call
10bbba00 docs: Document TERM_BACKGROUND_BRIGHT and TERM_FOREGROUND_BRIGHT
b3c08f81 term: Compatibility with latest terminal changes
fc6b69f0 host/limine-deploy: Add quiet option. Closes #243
382d8891 docs/protocol: Fix syntax highlighting of struct limine_video_mode
040a1581 Merge pull request #240 from TornaxO7/add_docs_to_stack
98bfcc6d adding bytes description to stack_size
6df8a356 Merge pull request #239 from Lockna/errata-protocol
3fc36e9a docs/protocol: Fix wording for reserved/reclaimable
25c6c18c Revert "fs: Drop ext* support"
0748cf5b Revert "fs: Fix unused variable warning introduced in ba5aca6f"
a4803614 fs: Fix unused variable warning introduced in ba5aca6f
ba5aca6f fs: Drop ext* support
32d7aa18 Merge pull request #238 from qookei/fix-aa64-fbs
04d22b1e limine: Fix caching mode detection for multiple framebuffers on AArch64
ffaaabf1 readline: Fix issue arising from terminal's wraparound handling fix
c2854bde gop: Fix small issue causing IA-32 UEFI port not to build
f9399fd5 disk: Fix issue where _p struct was not zeroed out in create_disk_index()
15127263 Merge pull request #236 from beakeyz/memleakfix_disk_create_index
d39baeaa video: Initial support for multiple framebuffers
28187433 Fixed little memory leak in the UEFI build that would make the bootloader crash on systems with larger disks
9b68f081 docs: Add packaging status to README.md
bf4c0f7d gop: Remove ConOut logic
99f8c7b1 Merge pull request #234 from raccog/trunk
e924aa5f gop: Use ConOut to obtain GOP whenever possible
97029246 limine.h: Use C90 style comments for license header
60c11565 Revert "gop: Allow user to select which GOP to use in config. Addresses #233"
20572082 Revert "gop: Fix implicit declaration warning introduced in d82dc64b"
07d8dd2c readline: Fix command line scrolling and cursor wrap-around
c477414c gop: Fix implicit declaration warning introduced in d82dc64b
d82dc64b gop: Allow user to select which GOP to use in config. Addresses #233
22c041ff limine.h: Add license header
1258f01b Revert "smp/x86: Free up trampoline memory after use"
144c481e docs/protocol: Clarify file address alignment
7e403e00 multiboot2: Support load_addr == -1
ae771dd8 smp/x86: Free up trampoline memory after use
49f4ccd3 pmm: Work around potential memmap data race in EFI init_memmap()
09faf82b pmm: Fix AllocatePages() call to take pages count; remove useless alignment check
d8193abc pmm: Avoid throwing away big memory ranges that fail to AllocatePages() indiscriminately
ce4046d5 Revert "ci: Build and check using Alpine instead of Arch"
7e1d4a98 linux: Revert 793d0293
3c541576 disk: Fix wrong parameter passed to ReadBlocks()
c7e62083 docs: Document blake2b checksums related things
f0d6aa80 docs: Fix formatting issue in PROTOCOL.md
c14bb605 gop: Do not zero default_res out erroneously
e0aec79c limine: Add support for framebuffer modes listing
01ee0937 file: Reimplement a1bcf3c0 without use-after-free bug
502f77b3 ci: Build and check using Alpine instead of Arch
42b1db10 misc: Update references to hardcoded directories
b30d2dc9 disk: UEFI: Add BLOCK_IO fallback for volume_from_efi_handle()
da5896b7 disk: On UEFI, improve optical vs non-optical detection
6022f5bf elf: Add overlapping PHDR detection
96fe1aa2 disk: Only use BLOCK_IO as fallback to DISK_IO when determining optical
d265cad7 disk: On BIOS, change how optical is determined
ce33e9df limine: Fix bug which triggered on no-NX where wrong register was used for rd/wrmsr
fa40b927 docs: Update README.md
d10d2bad menu: Add arrows to indicate overflow for many menu entries
af80341c misc: Dynamically allocate EFI memmap copy
53d20619 menu: Properly handly high number of entries
2557aa8f misc: Increase EFI_COPY_MAX_ENTRIES to 2048
4ba1b2fd limine/smp: Fix stack offset accidentally added twice
3d95c896 misc: Add limine subdir to stage3 and config search paths. Closes #225
23f2c7db Merge pull request #228 from czapek1337/some-fixes
02c26a87 efi: Fallback to volume scan instead of panicking
b1319408 menu: Add missing valid keys
7f09259c term: Misc improvements for SERIAL=yes on EFI
610a98d8 term: Unbreak textmode + serial combo
6e1c792e gterm: Prevent memory leak gterm_init() failure
fb994e61 limine: Fix NULL term dereference bug if gterm_init fails
44a3f3f2 disk: Use BLOCK_IO instead of DISK_IO
68e936e7 readline: Fallback to SystemTable->ConIn
ac34ec41 term: Better ensure term is not accessed when NULL
ec9d384b limine: Do not panic if failing to set up terminal or framebuffer
cc8ff908 menu: Use fallback terminal instead of panicking on gterm_init() fail
6cbb9c45 limine: Fix bug where NULL term was accessed. Fixes #227
ffa6d4e0 limine: Reimplement proper callback functionality
d187c576 term: Make term_notready() static
ff8c5f31 term: Gate BIOS specific code behind ifdefs
f977548e term: Reimplement context control
48a7c12e term: Misc fixes and improvements
d3c8a669 term: Misc fixes and improvements
b34954bb term: Misc fixes and improvements
45312e66 term: Add builtin font
f6ba5991 term: Misc minor bug fixes
0f1d86e7 term: Tidy up VGA textmode wrapper code
8849d08e term: Tidy up gterm wrapper code
4d855fc1 term: Move to use external, portable terminal
e466501f pmm: Misc bug fixes in pmm
96c184fd term: Misc bug fixes in fallback backends
7f046f67 build: Use variables to determine installable files instead of ignoring errors
e5d78615 docs: Update README.md in preparation for version naming scheme change
0d7b1e11 term: Do not reset mode on UEFI fallback init
00e9f2ce multiboot: Fix warnings when building BIOS port
a2ba71eb multiboot: Allow for headless boots
c849bfc1 pmm: Obtain raw memmap from untouched_memmap rather than EFI memmap. Addresses #222 and https://forum.puppylinux.com/viewtopic.php?t=6881
bd7c3602 pmm: Keep first page on sanitiser call in get_raw_memmap()
97c928a3 pmm: Backport some other stuff reverted in 4a4409e1
64c897a8 pmm: Backport fa6f6077 and 74a3a1c6
714d8ac2 Revert "file: Convert file to a memfile as soon as possible"
4a4409e1 pmm: Undo most of what was done between 85603ec8 and 74a3a1c6
0cb98610 panic: Fix build on non-BIOS targets
e062b4ed term: Move more of it to stage 3
e67a75fe Revert "linux/efi: Perform efi_memmap_size=0 workaround for 32 on 64 as well"
34a53292 build: Update install commands to be more quiet on non-fatal fail
b9f41799 linux/efi: Perform efi_memmap_size=0 workaround for 32 on 64 as well
39037253 build: Update build option dependencies and names
b229d0cd config: On UEFI, scan the volume containing the EFI executable first. Addresses #219
0a28a095 build: Honor LIBS variable
dab2a35b build: Honor CPPFLAGS variable
d5ff4467 menu: Fix regression when pressing a key during quiet timeout wait. Addresses in part #220
b1bfa2d2 build: Fix issue introduced in 87e09dba
a6189abd misc: Fix bugs introduced in 3181293a
e89d8344 disk/efi: Improve firmware error handling
87e09dba build: Plug back limine_stage2only.elf into the BIOS build system
59bbd1f6 menu: Avoid reinitialising fallback terminal on first runs
26f6ac3b smp: Fix indentation
dc5ed66e efi: Limit amount of tries to get boot volume from handle
f86a4212 misc: Fix up some no_unwind globals
0ae552a2 misc: Misc stage 2 related improvements
7f14f2f0 misc: Improve printing effectively on panics and errors
e76c8d47 multiboot2: Fix broken EFI memmap length calculation
50b52483 efi: Ensure panics are (hopefully) always visible
88652335 efi/disk: Use blake2b to calculate unique sector hash
430e8419 build: Do not request readelf from cross-detect when not needed
708868c8 build: Change name of --enable-uefi-x86_64 option to --enable-uefi-x86-64
a95d475c build: Only check nasm and gzip presence as needed
2b71eaed smp: Fix aarch64 issue introduced in 0f04f686
0f04f686 smp: Remove hacks needed for stivale
7e6aad31 build: Fix stage2 map
ae460593 misc: Minor cleanup after #216
c1e98f26 Merge pull request #216 from czapek1337/blake2b
9680a1ad uri: Add checksum validation
71eb1436 print: Specifier for printing URIs
a1bcf3c0 file: Convert file to a memfile as soon as possible
8906518c crypt: Implement blake2b hash function
f8d71431 Merge pull request #217 from Andy-Python-Programmer/trunk
528be723 DTB: ensure the `dtb_ptr` is an HHDM address
82eb8091 elf: Fix issue where KASLR was applied to non reloc executables
fe00a3c4 (tag: v4.0.1) build: Updates for new cross-detect
3452e492 elf: General refactor
3b7b170c Merge pull request #214 from Andy-Python-Programmer/trunk
4fb558fe protocol: `dtb_ptr` should be a virtual pointer
55662787 (tag: v4.0) textmode: Load notready() *before* setting term_{cols,rows}
87d0dfa6 build: Further fix test targets
ebbf8d7b misc: Better integration of aarch64 port and test mechanism
86ebf0b4 term: Initial support for 256-color palette
67498a69 term: Initial support for RGB
b2a390c4 misc: Update wallpaper
07c446f2 build: Updates for new limine-efi
5e06a79f limine: Do not set NX bit in page tables if NX not available
d3385da3 limine: Make NX feature not mandatory
c44f5147 misc: Rename UEFI and BIOS define macros
1d325927 build: Remove unneeded libgcc files in make dist
27711e3c fs: Add case insensitive fopen() for config and system files
4702e912 gensyms: Do not escape # in substitution string
fb372e6d pmm: Make code to reserve page 0 uniform between BIOS and UEFI
4869c14c build: Fix cross-detect errors detection for aarch64
9b3570f0 bios/disk: Fix always-true comparison warning
1b630659 bios/disk: Add manual sector size detection code
c34db50c build: Small formatting fix
21fa4a96 build: Update for new cross-detect
9eade7fa build: Actually pull CC variable from autoconf
8d99eb49 build: Update decompressor compiler flags
57194bc1 build: Default to -O2 optimisation instead of -O3
5f61730f build: Update decompressor compiler flags
44df23c8 build: Update linker and compiler flags
c528068a misc: Fix improper panic() calls
6631b595 build: Pretty up find calls
07080dcb misc: blib.h -> misc.h
65671d73 misc: Update several macros
16c5e981 misc: Update ALIGN macros
9c389ced build: Fix failure on running ./bootstrap with pre-downloaded libgcc-binaries
b40d2180 limine-deploy: Fix bug where undeploy() is reached with uninitialised device
2e52a41e build: Remove unneeded libgcc files on bootstrap
a91abf2c build: Handle -no-pie bug with cross-detect
fde04478 fs: Drop NTFS support
20305f34 ci: Mark releases as prerelease
5f7cb5c8 build: Properly set target arch on objcopy to ELF
94eb0e2a entry/uefi: Only perform 4GiB check if on x86_64
ed0c32f2 entry/uefi: Abort if loaded above 4GiB. Fix #206
a89b8436 Revert "bios: Get rid of self-modifying interrupt call code"
7d66c80b docs/ci: Changes in preparation for 4.x release
0c149dd1 Merge pull request #210 from qookei/fix-align-arm
489450d6 common: fix alignment of variable in AArch64 menu thunk
04a6389f build: Improvements and updates for new limine-efi
2460b33f build: Misc build system improvements
c626e63b build: Fix #208
a17edef7 ext: Fix next_cwd_len calculation
45f65b6b ext: Fix abs-path related bug with symlink handling
fe637af4 ext: Properly follow relative symlinks
af4fb9a3 Merge pull request #207 from DeanoBurrito/trunk
83a216ea Protocol: spelling
e1f6ac88 Initial AArch64 port (#205)
664a872d editor: Add TERM_CONFIG_OVERRIDE to syntax highlighting
5f1680ac build: Misc improvements to makefiles
1e9ac0ac build: Update makefiles to not use INTERNAL variables
17e23dd7 build: Discard .eh_frame section in linker scripts to fix potential GNU toolchain miscompilation
fb2a6e1f limine: Remove stray external symbol declaration
997c787c term/limine: Allow overriding terminal config in entry
11b56c39 config: Only make keys global if before first entry
73f958e9 Revert "Revert "gensyms: Use as instead of nasm""
7ade45b2 misc: struct e820_entry_t -> struct memmap_entry
71fd2d25 pmm: Properly handle memory map entries that cross 4GiB on UEFI
bdcf562e Merge pull request #204 from dimich-dmb/trunk
b205ff9b misc: Fix GRAPHICS config option recognition
93f8d011 multiboot2: Fix bug where old ACPI tag would not get passed if RSDP rev == 0
656d853a decompressor: Update linker script
74a3a1c6 pmm: General tyding up of pmm code (2)
fa6f6077 pmm: General tyding up of pmm code
7a9a04d7 build: Always place -fno-pie before -fno-pic
dc3a81cb build: Drop support for building GCC toolchain
4422ebd6 build: Get proper mkdir -p from autoconf
e3c4fbea config: Remove stray include
793d0293 linux: Only make framebuffer EFI and 64-bit if above 4GiB
367bf3e5 linux: Find compromise for 32-bit EFI boot
4b55b453 pmm: Fix a handful of GCC warnings
0ef0c3ad linux, pmm: Get a boot with 32-bit UEFI. Addresses #185
0c7be497 docs: Update README.md
c43acd44 limine: Drop legacy framebuffer and terminal requests
cd1107ab limine: Specify that memory between 0 and 0x1000 is never to be marked usable
eaeeb59b docs: Update README.md
c23eac80 mbr: Make detection more lax. Addresses #185
ff7d9502 smp: Make smp_trampoline_size variable instead of symbol
ccdd1ca6 smp: Do not calculate trampoline size in C file
77ed67e5 smp/trampoline: Use hand written pos independent code instead of objcopying
0a2c2896 Revert "pmm: Fix issue with get_memmap() that could cause page table corruption"
fb5d903c pmm: Reclaim bootservices entries last and disallow allocations after
4c6fba82 chainload: Add GPT_GUID support and improve documentation. Closes #201
7bfa2cd7 pmm: Fix bugs introduced in 85603ec
85603ec8 pmm: Simplify handling EFI memory acquisition and release
dcfef93f efi: Handle cases where untouched memmap entries are lower than current base
4859ee97 Revert "multiboot: Take better care of not having the reloc stub overwritten"
d2b15796 multiboot: Properly check elsewhere returns
b3ca8ae9 Revert "gensyms: Use as instead of nasm"
1c048e96 Merge pull request #199 from xvanc/trunk
bae4f502 limine: guarantee that SMP `goto_address` is initialized to NULL
a58e66a1 build: Move common/{entry.asm_bios_ia32 -> entry_asm.s2.asm_bios_ia32}
f2d611eb build: Remove unnecessary -mno-3dnow flag
f2337031 build: Remove unnecessary symbol overrides for stage2only
86fc022f misc: Move 'verbose' declaration to lib/print.h
6eafb4fc build: BIOS stage2only build improvements
22d45a54 build: Remove dummy limine-efi rules
37f72757 build: Update linker scripts and fix minor makefile issue
ffb4ba6f mbr: Relax MBR validation requirements. Closes #195
4dc295c9 misc: Fix broken memcmp()
8a8b62fb chainload: Fix bug where PARTITION was ignored if MBR_ID was set. Addresses #197
a41bc97e limine-deploy: Fix bug where sizeof(struct gpt_entry) was used where it should not
6a742881 limine-deploy: Greatly improve usage help. Addresses #197
dc0d9f8b limine-deploy: Add undeploy data save and undeploy mode. Addresses #197
c50e02ec stage1: Improve compatibility of HDD bootsector
82e62a96 host: Reorganise host-tools layout and add limine-version. Closes #196
2a448feb protos: Move 'loading kernel' prints where they belong
e5e12588 protos: Remove pointless returns added for autodetection
0af37b7c fwcfg: Drop support
447de819 docs: Remove few remaining mentions of autodetect
62c029c2 chainload: Implement MBR_ID config option. Closes #190
fb75a687 chainload_next: Fix some UEFI bugs
45118277 chainload_next: Pass config through to chainload on UEFI
abd641bb protos: Fix typo in chainload_next.c
95272c5f protos: Add chainload_next protocol. Closes #191
1ac13430 mbr: Add extra FAT32 and NTFS signatures to validity check
abf86a56 fat: Make signature checking even more lax
5e0f8572 bios: Get rid of self-modifying interrupt call code
b1672e4a fat: Loosen up check more and lower its priority in file.s2.c
afedae6d fat32: Swallow 0x28 and 0xd0 extended boot signatures
71adb6b3 console: Set config_ready to true after successfully running editor
c12a6979 build: Remove cross toolchain variable definitions from root makefile
7d78cf4e part: Also print fslabel in lsvol
7895c682 ext: Return NULL from get_label() when no label is present
eafff620 uri: Fix call to panic()
ff5d7451 fat: Fix volume label detection
00b9f442 limine: Fix assignment of paths broken in 0431623
7db783f0 edid: Undo comparison change from 29d63d6
180eb849 part: Misc EBR-related bug fixes. Fixes #189
7cf1b66a docs: Update README.md
009fb59b multiboot: Take better care of not having the reloc stub overwritten
8e54ea46 protos: Remove ugly .32.c files and replace them with pure asm files
1dd81d45 build: Add DWARF debugging sections to linker scripts
187628c3 docs: Update README.md
6106285d build: Move to using external cross-detect package
04316233 fs: Improve layering in how the filesystem API works
1843b260 build: Minor configure.ac adjustments
48318c25 limine: Fix bug where HHDM would be randomised even with KASLR disabled
c1c97617 build: Fix version.sh for when it is ran from a different directory
0dcd5292 docs: Document fslabel://
51b36a79 config: Fix macro parsing and expansion bugs
8f8af188 build: Make sure autoreconf -fvi is able to reconf tarballs. Fixes #187
2f0d48ab build: Undo changes that made reconf impossible in tarball releases. Fixes #187
effb8232 config: Fix issue with configs without trailing newline
0f5a467a uri: Add fslabel:// URI scheme as mentioned in #188
857dcbbf part: Fix broken sector count normalisation calculation
0a7c1be0 part: Fix implicit declaration warning
20640083 part: Fix long standing issue with GPT logical block sizes and implement lsvol console command
f3621c7b acpi: Add EBDA address sanity checks and work around bogus GCC warning
29d63d6b gop: Use LocateHandle/HandleProtocol to get GOP instance
55199478 efi: Fix broken assignments of handles_size
f9e90da2 efi: Fix potential issues with LocateHandle invocations
098e8679 build: Rename freestanding-headers to match upstream
af2f9221 multiboot: Do not panic if unable to set text mode
b0af0ac0 build: Normalise amd64 CC_MACHINE to x86_64
0fac035a multiboot2: Add stub support for relocation header tag
2b5f1039 multiboot2: Improve multiboot2 test case
b899d1ac multiboot2: Remove useless, broken comparison
a1bf3738 multiboot2: Bring framebuffer tag up to par with mb1
77b405a6 multiboot2: Bring a.out kludge up to par with mb1
94a20e64 multiboot: Fix relocator assembly issues
3d65bfb9 misc: Misc elsewhere and multiboot-related bug fixes
215bf879 misc: Bring mb2 up to par to mb1 wrt everywhere ranges and bug fixes
19287d5c misc: Add elsewhere TU and rework mb1 to use it
e436b763 elf: Add elf*_load_elsewhere() functions
4e0ec6d5 elf: Undo all the mess caused by multiboot in preparation for separate functions
a2f7d2d3 multiboot1: Add ahead-of-time info size calculation
d7d0a844 multiboot1: Properly support relocation for a.out kludge kernels and bug fixes
fba565b3 elf: Add support for sliding and ELF ranges to ELF32 as well
f62345ee build: Add generic x86 asm extension grouping
27e2b84e elf64: Do not align ELF ranges if using paddr
b9400d2f multiboot: Backport b92d48e to multiboot1
b92d48e4 multiboot(2): Initial support for arbitrary kernel load addresses
ee688073 deploy: allow non-positional --force-mbr (#186)
0836a62f pmm: Minor overhaul to try and fix #185
b8a3534a build: Unbreak version.sh
a2ac499c build: Pass -D__USE_MINGW_ANSI_STDIO when building limine-deploy
a611b358 build: Fix make_toolchain.sh download link in bootstrap
27814965 docs: Update in praparation for Limine 3.8
874db16c gh: Run release workflow on Arch Linux container and build with LLVM
ff9649f6 build: Remove make_toolchain.sh in maintainer-clean
5c7e1839 build: Version file in tarballs is no longer needed
2280e2c3 build: Pull make_toolchain.sh on bootstrap
79b0d531 build: Remove extra junk from release tarballs
f23c280a Merge pull request #183 from alicavus/patch-1
153204e8 CONFIG.md: duplicated text removed
9c180b40 pmm: Fix issue with get_memmap() that could cause page table corruption
6875ee70 decompressor: Add memory routines
7415137a misc: Update default font
4b32083a build: Misc improvements
9f00d613 build: Update for newer limine-efi
7fb17ce9 Update multiboot1.c (#181)
2590c5ac build: Remove useless LIMINE_AS
ef4e014c build: Use libgcc-binaries
75c3585e build: Use binary libgcc from GCC instead of our own stubs. Closes #180
547666ca gh: Run check workflow on Arch Linux container
99cb8f26 build: Do not export $TOOLCHAIN from toolchain-files
ed89ebe1 build: Do not check for $TOOLCHAIN-cc
53a2dbef build: Improve toolchain detection
dc3de36c Merge pull request #178 from lightning-speed/patch-2
9ba7ba47 ext: Turn presence of encryption feature to a warning. Closes #179
1e47160a multiboot: Fix section location calculation
2f07cb36 Update menu.c
3ef8a299 multiboot1: Add ELF sections load support
77fa71ae multiboot2: Use correct section list copy for section loading
15ab3d77 multiboot2: Fix broken section list size calculation (3)
ab84448b multiboot2: Fix broken section list size calculation (2)
ded43b60 multiboot2: Fix broken section list size calculation
7f6ac2d1 multiboot2: Add mb2_alloc() for quirky allocation locations
7eac8416 build: Run toolchain-detect at configure time
5b181e10 term: Move notready and fallback backends to stage 2
7404cb46 build: Add toolchain-detect
0c084e37 build: Remove useless x86-specific test from configure
539ac945 build: Disable all ports by default
1fc8247a build: Increase portability of Makefile targets
dcd59daa build: Make bootstrap not call configure
8981575d protos: Drop autodetection support
e906d059 build: autogen.sh -> bootstrap
ee69dacb fs: Drop echfs support
13b9a333 build: Update due to limine-efi rebranding
746d0ad5 protos: Drop stivale and stivale2 support
564044ec (tag: v3.5.4) stage1: Fix sector loading asm bug
57f384ee (tag: v3.5.3) gop: Ensure QueryMode() is called properly
3b60c7bb Revert "gop: Force 32 bpp for preset mode fallback"
571374fd Revert "gop: Potential workarounds for modesetting issue"
cf8f4f86 (tag: v3.5.2) gop: Potential workarounds for modesetting issue
ab79b956 (tag: v3.5.1) elf: Load non-load sections in memory for multiboot
9a89e72d multiboot1: use config_get_tuple when appropriate
67b75fa0 multiboot2: use config_get_tuple when appropriate
dd0790a5 limine-deploy: Fix bug where any_active is not properly set
0d07b9db (tag: v3.5) build: Remove test and screenshot.png from tarballs
3dbed1dc gop: Force 32 bpp for preset mode fallback
c9f4f6be fb: Change reactions of protocols to high fb sizes
f77b1f80 gop: Use EDID only if of better resolution than preset
b11b21df fb: Expand width and height to 64-bit
0d1871dc docs: Update README.md
683b38ab limine: Document new requests for terminal and framebuffer
9585dcbd limine: Add new requests for terminal and framebuffer
3d9737f5 (tag: v3.4.7) build: Configure improvements
4205f7cd gensyms: Add exit traps
6036679a misc: Work around GNU binutils nonsense
76be5313 (tag: v3.4.6) misc: Sanitise decompressor linker script
7c7dd0d2 misc: Sanitise EFI linker scripts
4aed1aca misc: Further sanitise BIOS linker script
65c9ddaa misc: BIOS linker script fixes for LLD
6051fdf5 misc: Make BIOS port PHDRs explicit
440c1383 toolchain: Update GCC to 12.1.0
1f1cad1a Revert "decompressor: Use as instead of nasm"
688c118c (tag: v3.4.5) limine: Ensure framebuffer pointer of terminal is always valid
39559b39 decompressor: Use as instead of nasm
cb9c097b gensyms: Use as instead of nasm
e836fb44 (tag: v3.4.4) limine: Only acknowledge stack size req if new stack > default
8806f470 workflow: Install lld in check workflow
0c46c16a fat: Add missing semicolon
c8973ed6 fat: Improve detection code
c2249297 elf: Do not assume relocatable unless DT_RELA present. Fixes #170
650c1443 Merge pull request #171 from ilobilo/patch-1
ce7c561e Stack size
52667354 docs: Fix wrong sentence in Limine spec
7430cb9a Merge pull request #169 from NateDogg1232/patch-1
43f817f7 Specify the starting index of revision numbers
b0c59cc0 (tag: v3.4.3) efi: Updates for new reduced-gnu-efi
0cd9dba8 (tag: v3.4.2) toolchain: Update GCC to 11.3.0
cf7d9e73 readline: Fix 1 uncaught NULL deref
cac57ced menu: Fix 2 uncaught NULL derefs
d454935e (tag: v3.4.1) efi: Update linker scripts for new reduced-gnu-efi
4e349fe0 (tag: v3.4) ci: Use TOOLCHAIN=llvm to test LLVM builds
64e9c11d build: No longer hard depend on GNU binutils
df7e43df efi: Adjust for new reduced-gnu-efi
1af09d07 mm/efi: Fix issue where in-use bootloader memory may be erroneously allocated
8cb61a95 (tag: v3.3) build: Fix targets that built redundandly on install
e22d5eff limine: Increment default stack size to 64KiB
fbf1e158 term/protos: Do not call callback if NULL
ddf248aa (tag: v3.2.2) limine-deploy: Move code to activate partition to after MBR detection
e5f2b2c0 (tag: v3.2.1) limine-deploy: Do not mark any protective MBR partition as active
d8180342 (tag: v3.2) efi: Do not panic if GetMemoryMap() fails after first ExitBootServices()
3baa802f limine-deploy: Auto set an MBR partition as active if none found
98b54eaf limine-deploy: Remove leading underscore from limine.hdd variable name
af330e12 limine-deploy: Use EXIT_FAILURE and EXIT_SUCCESS
4202402b limine: Ensure framebuffer memmap entry is always generated
93ce137a (tag: v3.1) limine: Document Requests Section
dae89270 limine: Add support for .limine_reqs ELF section
15267d85 (tag: v3.0.3) build: Misc Makefile fixes
9f2f6069 (tag: v3.0.2) build: Fix out-of-tree builds
ca1cc67f (tag: v3.0.1) build: Use SHESCAPE on autoconf include dir variables
4fb7fd8c build: Misc Makefile fixes
78a482e5 build: Add limine.h to make uninstall
73883696 build: Install limine.h header file
e8bab04a build: Use autoconf generated install dir variables
bcced191 misc: Get rid of latest-binary
5c7578c5 (tag: v3.0-rc11, tag: v3.0) limine: Add media type to limine_file structure
012e7b0b misc: Fix minor things accidentally reverted in 790a130
790a1303 Revert "limine: Initial support for non-ELF executables"
5f525a10 limine: Change terminal write contract
c0525095 misc: limine-s2deploy -> limine-deploy
fb175747 (tag: v3.0-rc10) limine: Add support for multiple terminals and properly document it
15f111f5 limine: Make WP flag enabled as per spec
6caaada6 (tag: v3.0-rc9) limine: Rename 2 limine_file members
a75d3348 s2deploy: Fix bugs with 4dcd94f
4dcd94f4 s2deploy: Make it big endian aware
e1f3d223 (tag: v3.0-rc8) smp: Make RDI pointer higher half aware
1fd47241 (tag: v3.0-rc7) misc: Do not copy limine-hdd.bin to binary branch
6f8474c2 misc: limine-eltorito-efi.bin -> limine-cd-efi.bin
84394f0d limine: Fix typo
42402560 (tag: v3.0-rc6) limine: Initial support for non-ELF executables
abc3b309 gterm: Default to transparent bg if wallpaper is set
5045a266 limine: Add extern "C" C++ guards to header
a688a1dd (tag: v3.0-rc5) limine: Add stack size feature
b4fd10af limine: Document added padding field of file structure
647ad0ac limine: Add missing padding field from file structure
2917932d misc: Initialise terminal before randomising memory
41ea16e2 elf: Return is_reloc
2cc4ff85 limine: TERM->TERMINAL
9391fa2e limine: Add missing terminal constants
6c7e5f87 uri: Assign volume to compressed file handles
c2a21f9b misc: Readd missing RANDOMISE_MEMORY implementation
e25dd260 limine: Add missing forward declaration of struct limine_smp_info
88a2cc6c limine: Fix definition of limine_goto_address type
8b2cafc8 (tag: v3.0-rc4) misc: Bug fixes
8b19de71 (tag: v3.0-rc3) editor: Remove useless VALID_KEYS
e8fcc85b limine: Rework modules/file/kernel_file
652b5447 limine: Make module paths better defined
8aa1372c (tag: v3.0-rc2) elf: Return image size
69557e9d (tag: v3.0-rc1) toolchain: Pull nasm from our website
e22d279c gh: git related fixes
8a2fafd7 gh: Do not build Linux version of limine-s2deploy
3c909c01 docs: limine: More documentation work
21f86405 docs: limine: Document SMP request
c4f04dab docs: Continue work on Limine protocol spec
2fa2fb22 docs: Initial Limine protocol draft
b2238c15 docs: Update readme
49a8dfe4 config: Misc improvements
99a4eaac config: Sanitise names of terminal keys
c78e47db limine: Change type of entry point pointer
733865c9 limine: Add terminal request
49cf4398 s2deploy: Misc updates
92a8661a gh: Drop building limine-s2deploy-linux-x86_32 and use musl
d7588e4f Merge pull request #164 from benjidial/trunk
1dd3885b and for tabs
66e3c5ef also do it on the first line
4df856f3 skip spaces at the start of lines in config files
65b5a7f6 misc: limine-install -> limine-s2deploy
01fd8257 limine: Header cleanup
80ba3950 limine: Use arrays of pointers over arrays of structs
414fb384 limine: Fix wrong variable name
fb19f6bc Revert "limine: Move module request to using SoA"
40e0f3fd Revert "limine: Move memmap request to using SoA"
2ba37707 Revert "limine: Move SMP request to using SoA"
b2211a7e Revert "limine: Move framebuffer request to using SoA"
2d048ecf limine: Add kernel address request
f487061f limine: Add boot time request
38233a24 limine: Add EFI system table request
a65e6ca9 limine: flags -> revision
f39578f4 limine: Move module request to using SoA
82627d86 limine: Move memmap request to using SoA
03700dea limine: Move SMP request to using SoA
76b9312d limine: Move framebuffer request to using SoA
021bf509 limine: Separate bootloader info and HHDM requests
5b6c4ffc limine: Add EDID to framebuffer response
9f44fe6c smp: Make it higher half aware
3f5b29c3 limine: Add SMP request
fb54571b limine: PXE and HHDM work
ee5e776c test: Minor changes
50076656 limine: Add SMBIOS request
4f90e0c7 limine: Add RSDP request
a3d3e2bb limine: Exit boot services before memmap logic
30aed730 limine: Add kernel to modules request
a51f8a39 limine: Add modules request
1e62d993 limine: Add reserved space to size-sensitive structs
c180b59f limine: Add cmdline request
fd2b3d69 limine: Add framebuffer request
ea647588 misc: Panic improvements
80f8f434 limine: Add request conflict detection
5dd725db elf: Add more sanity checks
ee1b9f19 misc: Bug fixes
f9c9ec84 limine: Rework request-response system
e33a76bd limine: Add memmap feature
b2e614e7 limine: Introduce basic Limine protocol concept
c2b1be81 serial: Ensure DLAB off before initiatialisation
d6be4192 misc: New example background
b6d0a63a term: Fix deinitialisation issues
f3ffa872 elf: Use PHDRs instead of sections for resolving relocations
08547c0d time: Work around potential issue with day wraparound
f59a1eac readline: Support odd backspace behaviour from serial
af092292 term: Change default settings to prefer video to text mode
be2b099b gterm: Fix crash if margin==0 with a background
7db81efb stivale2: Ensure serial off before starting runtime term
44d3ba3b docs: Update README.md
3e1d9abf docs: Update README.md
271022e2 build: Lower required C standard for limine-install to C99
1207b8d9 build: Pass -fno-stack-check in decompressor build
5542dffa build: Pass -undef to preprocessor calls
b7183102 readline: Unify getchar() impl for UEFI and BIOS
4b5780dd menu: Use reverse video to highlight selected entry
9964c922 docs: Document serial support better
23ff2b0d misc: Ensure editor is not accessible from console if disabled
77e90fa9 docs: Document serial support
88122164 io: Complete serial support. Closes #155
1d2cb8e4 pmm: Fix alignment issue introduced in 3fe8217
c9c43797 efi: Do not fail on first ExitBootServices() attempt
f9048dbd docs: Update README.md
238f7df3 build: Build nasm as part of make_toolchain.sh
87bf32be build: Updates for new reduced-gnu-efi commits
09b4a5f3 build: Misc gnu-efi related fixes
3537dea4 build: Fix GNUmakefile.in issue introduced in 1984f40
c5d61e4e build: Unbreak out of tree builds
8cae79ab build: Add common/config.h to distclean
c6619ba1 build: Include config.h in sbat.c
1984f401 build: Use config.h for generated constants
34f07551 readline: Use .scan instead of .ascii to test timeout
225f1911 readline: Fix argument handling in sleep.asmb
92eef3fe build: Add more granular configure options
e898ef04 misc: Make VLAs a warning
3c34f4a6 build: Add freestanding_headers to GNUmakefile.in
27d19e6f misc: Use freestanding_headers rather than shipping them
d510a290 limine-install: Pass LDFLAGS to CC
419d4934 gh: Make sure ssh key has right perms
5d407dbd build: Minor build system tweaks
e4dc4608 build: Simplify BSD od workaround in hgen.sh
92896f95 build: BSD od related adjustments in hgen.sh
30d518f3 gh: Upload release tarballs to website
b5bb4a65 build: Fix order of toolchain dirs in PATH
459029ee build: Make build system search for toolchain in source dir too
9afaa5fa make_toolchain.sh: Bump binutils to 2.38
c9fd1307 hgen: Add missing set -e
b138b195 limine-install: Make hgen a shell script
b80fb367 misc: Misc Hyper-V related fixes. Closes #150
bcf01fa3 build: Improve eltorito-efi configure option
23ee0bf4 build: Make eltorito-efi build manually toggleable
319326a7 misc: Misc output fixes for serial support
b51f2528 readline: Support C-[ae] for HOME and END
6e0fde5c menu: Support HOME and END shortcuts
aae5e6f7 menu: Support using 1-9 to boot menu entries
7d70e312 build: Minor portability fixes
400202d9 misc: stage23 -> common
8920c89a build: Unify and preprocess linker scripts
9332a9f4 build: Misc improvements
d7b8c3cf build: Misc improvements
e4bd2cfd build: Move program detection logic to configure script
ac865be1 build: Minor misc fixes
9fc8ec0c pmm_randomise_memory: Add guard for BIOS port to avoid accessing bogus pointers
3fa7d9d1 chainload: Assume boot drive if DRIVE parameter is omitted
69529b12 chainload: Readd wrongly removed noinline attribute
ea4db246 Merge pull request #154 from czapek1337/trunk
a6f6958b readline: Don't delete input beyond a null terminator
77ed9d23 console: Use escape sequence instead of reset_term()
077341d1 console: Add a clear command
53e515e6 readline: Zero out the buffer before using it
2c160408 readline: Handle END/HOME keys
0c677d09 console,editor: Filter out non-printable characters
ca5f7a6e menu: Handle uppercase inputs for menu hotkeys
019dddcc limine-install: Fix issue introduced in 55166fd where GPT checksum would corrupt
1cdb4c28 Merge pull request #153 from Itay2805/trunk
92580a3b ntfs: allow for bigger resident index and resident data
b023b96c build: Add *.tar.gz to maintainer-clean's rm
3afb2517 build: Add *.tar.gz to .gitignore
e412997a build: Make limine-hdd.h target not check toolchain
fdd93826 ntfs: Change most panics into prints
2db3240b paging: Some 1GiB pages adjustments
68faef19 misc: Various fixes
3ea53247 misc: incbin -> hgen
8670057e build: Makefile fixes
580a2c34 limine-install: Make it pure C11
55166fda limine-install: Overhaul
9fc15b37 Merge pull request #152 from Andy-Python-Programmer/trunk
c506f35d stivale tests: fix BUG: Unidentified tag 0x9b4358364c19ee62
10b585a9 Merge pull request #151 from Andy-Python-Programmer/trunk
061c8aa3 is_1gib_page_supported: use printv instead
e64eeef6 is_1gib_page_supported: use (void), not () if there's no args
66d59410 vmm: fix implicit declaration of print
4af12fe5 paging: emulate support for 1gib pages if not avaliable
51f5e5b0 direct_map: use 1gib pages to construct the direct map
45ecb0fb stivale_build_pagemap: use 1GiB pages to map 0 to 2GiB at 0xffffffff80000000
8866470d map_page: add support for mapping 1GiB pages
d51d5ccc map_page: take the page size as an argument (enum)
80ae303b misc: Fixes for GCC 12 warnings; add extern prototypes for inline functions
d3070566 misc: Disable strict aliasing, just in case
5aab6209 panic: Add missing ifdef
5b3e8c39 bios: Move terminal entirely to stage 3
d0433e1c limine-install: Do not use void pointer arithmetic
1ed5ee7e build: Manually copy install-sh into tarball
97231ac9 build: Make automake *copy* missing files
efc5084a misc: Small NTFS test case tweak
9ce5f54e misc: README.md and workflow updates
a0a8b3c0 build: 'install' portability fixes
e616f193 build: Remove stray rm from make_toolchain.sh
c28e3a6f build: Misc portability improvements
b1a7c0d1 Merge pull request #149 from Itay2805/trunk
c74c3644 added support for resident files, this should pretty much complete a basic support for NTFS
35d522d3 added required fixes to make ntfs work again
48d8b599 build: Add more targets for which toolchain is not checked
d1cc9700 gh: Update release workflow
230a1aa4 build: Move make_toolchain.sh to root
a25129b8 build: Even more portability improvements
64467c06 build: Further portability improvements
7b0c430f build: Misc portability improvements
65ef9561 misc: Do not rely on libc-provided headers
8de42af1 menu: Allow space for booting entries. Closes #148
4d6e1b80 term: Support for reverse scroll, save/restore, and bug fixes
58a3954c build: Add install-strip target
f82b3cb7 build: Disentangle some makefile targets
fd09538f build: Sanitise variables before building reduced-gnu-efi
accb58e1 multiboot: Retry failed module loads at different addresses
62ef88a9 build: Clean all temp autoconf files in maintainer-clean
26641eb1 build: Misc build system improvements
11f9786d build: Fix make call in limine-install target
5c9426e9 build: Add make uninstall target
4b65a49d build: Fix autogen.sh invocation in make dist
ceb1b80b Merge pull request #147 from ilobilo/patch-1
7a74d2d0 added slash
4fd8fd10 build: Fix up version.sh
3bb70dcb build: Move to using autoconf
88e7bcc1 disk: UEFI related adjustments
6223f65b Revert "disk: Fix logic issue with UEFI volume detection"
0eba7b0a Revert "disk: Bug fix in find_unique_sectors()"
a9e8f328 disk: Bug fix in find_unique_sectors()
3277ad25 build: Make install should not depend on all
96bcbfde multiboot2: Pass actual size of all tags rather than allocated size
ff63edc7 ext2: Do not panic on feature checks when testing signature
19bd7816 disk: Fix logic issue with UEFI volume detection
93ab7a2a gh: Update issue template
e83ae588 ext4: Fix bogus pmm_free() bugs. Fixes #146
17c59eeb disk: Limit size of fastest_xfer_size on UEFI
a494a1d4 term: Move fallback logic from panic.s2.c to term.s2.c
8f84178d Merge pull request #145 from streaksu/trunk
0eebfaa5 disk: Make disk_read_sectors() return errors instead of bool
a14bf5b2 build: Makefile -> GNUmakefile
fa791322 build: Makefile improvements
cc8528e2 disk: Fail disk_read_sectors() on any error code
6fad1202 disk: Use stdalign.h instead of GCC attribute
7a0bf62e misc: Update copyright years
3402b22c misc: Move to standard C11 noreturn
97eaf277 volume: Catch xfer_size==0 condition in cache_block()
63c3f48f libgcc: Small __*divmoddi4 bug fix
5b3dab30 volume: Fix bug where reads close to the end of drive may fail
e70f48c9 limine-install: Fix broken argc comparison
d948b6e9 chainload: Fix up drive number passed to spinup()
245bea9e build: Misc Makefile improvements
e9383335 stivale1&2: Allocate kernel with the right memmap type for 32-bit
b332e858 build: Improve clang detection code
364809bc lds: Move build-id inside limine.sys size area
62e9936b fat32: Do not hardcode sector size
d63149a6 limine-install: Add O_BINARY flag to open() on win32
a3890c9e build: Fix makefile race condition
966b4e54 build: UEFI linker scripts adjustments
66ac7098 build: BIOS linker scripts adjustments
ed82bd61 build: Remove useless subsystem objcopy argument for UEFI
5ae2433f menu: Do not reset term on editor exit to menu
8977863d Revert "build: Small change to EFI objcopy command"
cd4431f2 config: Misc macro improvements
b5808884 config: Implement macros
4cb616bc panic: Prevent recursive panics during early boot
1e69aff0 build: Small change to EFI objcopy command
acdd2134 misc: Add no_unwind to some variables
f0cda173 misc: Implement .no_unwind section
88cd9dca misc: Unwind both .data and .bss
2f66e0f2 menu: Fix stack alignment issue
5fb4f68a console: Add editor command
d021d6ff menu: Fix panic menu-reentry with TIMEOUT=0; fix entry assembly
edad956e misc: Allow recovering from panics
0d8037a4 Revert "stivale2: Add stack validity check"
9131aee1 Revert "stivale2: Only test stack validity if in top 2GiB"
2891c3c4 menu: Add missing semicolon after label
f50bbcd9 menu: Move protocol logic from entry.s3.c to menu.c
d0e0248f misc: Use %p where appropriate in prints
48828f31 misc: Move to assembly for mem family functions
0f35483e stivale.32: xorq -> xorl
b1bbcc46 elf: Use right print format for panic
59f66809 menu: Fix editor bug with cursor wrapping
68c7e265 build: Move to reduced-gnu-efi
415a57be build: More Makefile improvements
84c8dce0 uefi32: Fix bug introduced in 2f844f3
477a04b6 build: Makefile improvements
2be3776f linux: Ensure loading message shows up before fopen() for modules
eaea24f5 stivale2: Only test stack validity if in top 2GiB
4a59ba6b stivale2: Add stack validity check
e127b6c8 elf: Print out range addresses on allocation failure
beffb3e9 elf: Add guards to prevent non-higher half 64-bit kernels from loading when using PMRs or fully virtual mappings
6fad01e8 build: Fix various test targets
ce37d327 pmm: Mark Limine image wholly as bootloader reclaimable in memory map when using UEFI
8aac4785 Merge pull request #139 from pitust/trunk
73f28164 config: add mire detail to simple mode fw_cfg autodetection
4de17a2b capitalize limine
e53e7166 fwcfg: document the features
ec4b0186 main: Add autodetection prompt instead of doing it automatically
79970493 elf: Silence excessive verbosity
98d5b205 docs: Remove warning about spaces in build path
21b625be build: Fix up MKESCAPE macro logic
6dcce5f7 build: Initial support for special characters in build path
99c42e76 Merge pull request #135 from pitust/trunk
0228c06d Merge pull request #138 from lukflug/trunk
a14143b5 aux -> build-aux
ea615eb9 fix my tabs
f5b3653d linux: Add TEXTMODE config option
6b0c9c4c vbe&gop: Add 24 and 16 bpp modes to list of fallbacks (see #137)
dab74fd8 linux: Fall back to text mode if unable to set video mode (see #137)
89f6d7dd Revert "build: Support spaces in build directory"
47bb8ce3 fwcfg: implement the fw_cfg interface
5da7b1fc multiboot1&2: Move kernel loading message to after detection code
2f844f3f stivale1&2: Pass higher half GDTR.base when returning higher half pointers
eea96cda gdt: Allocate GDT on the heap on UEFI
6c7fa692 pmm: Work around sanitiser side effect introduced in b5eea0c
4bb42789 multiboot1: Allocate root struct on the heap
735afcc4 stivale1&2: Allocate root struct on the heap
d815c3d7 build: Support spaces in build directory
01255704 stivale2: Implement slide HHDM header tag
6bcbfe9b protos: Implement autodetection
ad3e1756 stivale2: Implement boot volume struct tag
5555af66 term: Implement interruptible quiet mode
4a6aabbe panic: Mention CTRL+ALT+DEL in system halted message
65925ebc term: Bug fixes
237a3b31 term: Fix bug introduced by last commit
89fbcbe7 term: When using quiet mode, hide textmode cursor
a937eb42 term: Introduce quiet mode
4337ae1a build: Update documentation for new binary location
af2d2b2c build: Update release workflow for new binary location
1c6f2937 build: Do not full-path limine-install Makefile target
c4c3afc7 build: Add regenerate make target
eaef49b7 build: Allow out of tree builds
30b0657e test: Minor multiboot fixes
6e61b4bd pmm: Minor cleanup
202eac3d bootboot: Remove bootboot support from Limine
636164a8 bootboot: Further address some of the issues raise in #124
8b81412e bootboot: Fix potential buffer overflow in bruteforce_kernel() (see #124)
42cd7d95 build: Compile BIOS Limine for i686 instead of i386
6aba8dec bootboot: Check for the right architecture when bruteforcing kernel (see #124)
e0fefcf2 bootboot: Remove uselessness and compliance fixes (see #124)
907ddcd3 Merge pull request #131 from ilobilo/trunk
d3177cf7 Merge pull request #130 from Andy-Python-Programmer/patch-5
5ff418dd Update stivale.c
5873fc96 Update stivale2.c
7be818bf tests: add a basic test multiboot1 kernel
6a56a07d Revert "bootboot: add a delay when assuming the stack size"
9d4bf41e config: Implement and use config_get_tuple()
1e1a0f25 Merge pull request #128 from Andy-Python-Programmer/patch-4
f55b987d Merge pull request #127 from Andy-Python-Programmer/patch-3
8a1fb190 config: update to add multiboot2 section in protocol keys
8d25ad05 bootboot: make WARNING caps'ed for consistency
6867334e Merge pull request #126 from Andy-Python-Programmer/patch-2
15cff010 tests: add basic multiboot2 test kernel
1be24c3c bootboot: Fix spec compliance as noted in PR #124 comments
0c073fcc build: Get build-id from linker instead of generating a random one
2caf1eae bootboot: Bug fixes
93cd5b1d bootboot: General cleanup
99be5e2d Merge pull request #124 from pitust/trunk
252bc5e5 bootboot: add a delay when assuming the stack size
16cdaedc Merge pull request #125 from Andy-Python-Programmer/patch-2
44f87b03 config: document the behaviour if module string is NULL
610ae119 bootboot: remove random newline
db61f691 bootboot: fix two issues in bootboot proto
6cbc63a3 bootboot: finish writing the error lmao
9374fb4f bootboot: add initrd support, and add a warning about the init stack
4a3fa76a Merge pull request #123 from Andy-Python-Programmer/patch-1
15806697 stivale+stivale2: default to file path as the module string if NULL
c338f575 elf: Drop lower half program headers for PMRs
5006077c Merge pull request #122 from pitust/trunk
3338c8da bootboot: flush both the pic and the apic
8308cfb3 bootboot: fix all the bad bugs
6ce89e96 pmm: Better handling of creating new memmap entries
738095c4 stivale: Deprecate low memory area
f3aee7fe Merge pull request #121 from pitust/trunk
db3af4b5 bootboot: RAMDISK->INITRD_PATH, don't pass gST around for no reason, unsplit bootboot_spinup, flush the PIC only
c67d70d3 disk: Improve performance on UEFI
f1849007 bootboot: use printv where appropriate, and promote "no ramdisk" to a warning, also print more info about the symbols
e4ff1ecb bootboot: reaorder includes
7d55fee0 bootboot+elf: deduplicate ELF structures
e9dadcef bootboot: don't zero out the framebuffer
24d27f76 bootboot: don't mask IRQs
dfd347db bootboot: i swear this is the last CI fix
643db03a bootboot: fix the CI, again
b17a6503 bootboot: fix the CI
b6169503 bootboot: document the protocol and it's configuration options
a72a6848 bootboot: add proper support for env and ramdisk
6443900f bootboot: introduce support for the bootboot protocol
c5dfd77f elf: Fix bug introduced in dbbef9f
46cfa89b test: Remove KASLR=no from stivale1 config entry
576669b8 elf: Align range lengths to p_align
4f77bf37 pmm: Use untouched_memmap instead of memmap in pmm_release_uefi_mem
b5eea0cc pmm: Sanitise away usable entry parts below 0x1000
7619908d console: Remove license command
0fd0650b stivale2: Remove useless arguments to load function
948e97c2 entry: Remove useless term init before panic
00bbfe82 menu: Initialise terminal at autoboot if not ready
7eeadd71 elf: Fix bug related to overshoot check
057715b6 panic: Initialise a terminal backend if term is not ready
f46ed6d9 pmm: Sanitise out 0-length usable entries
094bc0c1 stivale2: Only print base addresses when fully virtual
dcd42280 stivale2: Introduce fully virtual kernel mappings (KASLR/PIE fixes)
dbbef9f6 stivale2: Introduce fully virtual kernel mappings (bug fixes)
c7eb6319 stivale2: Introduce fully virtual kernel mappings
6397010b build: Fix wrong path for version timestamp
f939d754 build: Add make dist target
46149eaf build: De-symlink LICENSE.md
e215f774 build: De-symlink tinf
87ced72d protos: Fix misc use-after-close bugs
8d5b1462 stivale2: Fix use-after-close bugs
87a62d7f asm: Reorganise assembly code to avoid symlink use
39b8b499 idt: Move dummy_isr() to its own assembly file
820921a4 build: Add guards to ensure GNU Make is used
3ff618f1 everywhere: Use pmm_free() in more places
f71e57af everywhere: Implement pmm_free()
05064540 build: Pull gnu-efi from our own GitHub clone
bac1d489 term: Undo most of commit 1332be4 as that causes a performance hit on QEMU TCG
0f7746c3 gterm: Center terminal grid inside terminal window
cb55eef4 gterm: Improvements and bug fixes in canvas drawing
f3e6ca63 build: Pass -mtune=generic
4f064b30 term: Check if any terminal is actually initialised in reset_term()
2b11825b console: Introduce Limine console
1e26c5fa acpi: Remove broken comparison from UEFI acpi_get_rsdp()
c2139b23 Merge pull request #119 from Andy-Python-Programmer/trunk
c528aa61 multiboot2: pass both of the smbios entry points if non-null
61b31cf4 multiboot2: add smbios tag
13fc2ce4 acpi: cleanup smbios lookup to use actual smbios structs
a3696411 Merge pull request #118 from Andy-Python-Programmer/trunk
0dd2bc62 multiboot2: add the basic memory info tag
2b88de75 Merge pull request #117 from Andy-Python-Programmer/trunk
725393b2 multiboot2: add the ACPI old tag
fd805e2d Merge pull request #116 from Andy-Python-Programmer/trunk
cce7fa4e acpi_get_rsdp: UEFI RSDP lookup return RSDPv1
80279359 Merge pull request #115 from Andy-Python-Programmer/trunk
60180f7e multiboot2: add the EFI image handle tag
10438e51 multiboot: Zero out all undefined GPRs before handoff
0e9d145b elf: Fix off-by-1 comparisons
a6acfb76 pmm: Workaround for cases in which AllocatePages fails during initialisation
244b4617 gterm: Cursor print bug fix
474c02c9 gh: Add missing checkout step to compile check workflow
624f1934 ntfs: Fix compilation errors
5e8cd503 gh: Add workflow to test for compilation failures
321eae8f Merge pull request #114 from Itay2805/trunk
f2486dcd Added support for resident directory indexes
02ea23ab Runlist elements are relative to the last runlist, so make that work
6cd265b4 Merge pull request #113 from Itay2805/trunk
893020f3 cleanup and bufixes ntfs is weird so we can't trust the names in the index since sometimes they are wrong (?) also the read function should return 0 for success and not read size...
0cb083b3 ntfs is now fully working, or at least we can boot limine with it
3f37d82c got directory reading and more specifically root directory reading
66564de7 We can now get file records from the MFT
10caa22b got basic mft parsing
eced6423 Added test to makefile
f59f1845 Starting to work on NTFS
34cfd0e5 (tag: v2.58) term: Fix bug related to scrolling regions
bca6f924 term: Overhaul (4)
1332be4e term: Overhaul (3)
bd4646f0 chainload: Misc bug fixes and improvements
fabf2aef term: Overhaul (2)
ea2665c5 term: Overhaul (1)
46e1380f menu: Misc editor improvements
b7176d5c bmp: Ensure that bf_offset + bf_size <= file size
5374e4e1 (tag: v2.57.2) bios: Call a20_enable() before doing anything else
dbab5f60 (tag: v2.57.1) apic: Do not attempt an APIC flush for protocols that don't mask IRQs
5a4a6151 (tag: v2.57) stivale: Pass the right number of arguments to common_spinup()
4d40e736 efi: Disable watchdog timer
56ceffb4 entry: Move some initialisation calls to after config initialisation
46be45fa spinup64: Don't smash argument registers when calling flush_irqs()
21b926fb idt: Move flush_irq() logic to stage 3
c2e279db protos: Remove now-useless pic_flush() calls
7637f94e apic: Improve pending IRQ flushing mechanism
289030a1 build: Resolve some potential dependency race on gnu-efi
f73a19b5 apic: Do not panic if APIC not found
5e023bce stage1: Misc improvements
b29a513e apic: Add logic to mask all IO APIC GSIs. Fixes #111
521cb172 (tag: v2.56) stivale: Make unaligned stack request a warning rather than a panic
04732c62 (tag: v2.55) multiboot2: Add support for EFI system table tag
33692555 multiboot2: Add support for a.out kludge and other enhancements
35273093 term: Cursor should flip palette
ab19d6cc menu: Clear line before reprinting timeout message
fe882a8b multiboot1 and 2: General fixes and cleanup
fa5fa057 term: Do not parse escape-abort characters when not in runtime mode
05eb70e9 (tag: v2.54) smp: Use rdtsc to delay rather than dummy port IO
ae02de79 multiboot2: Fix broken append_tag() invocation
4ad7081e multiboot2: Misc adjustments
90bdd0dc Merge pull request #109 from Andy-Python-Programmer/trunk
875d90d7 multiboot2: add copyright notice on multiboot2 header file
dab65041 multiboot2: add kernel modules support
7ce2354c mutlboot2: assert that we do not overflow the mmap tags
e17d34ee multiboot2: allocate bootinfo size AOT
8b8388b1 elf_section_hdr_info: return the info instead of void
7ad45e8d term: Fix bug introduced when moving from int to size_t for coordinates. Fixes #110
42f821f0 multiboot2: add EFI memory map tag
5d2ce0d1 multiboot2: add ACPIv2 info tag
de673e2a docs: Update screenshot
6f15587c multiboot2: add the framebuffer tag
6d034adc multiboot2: implement ELF sections tag
b9e7d51c readme and config: document support for multiboot2
60811e70 multiboot2: initial support
9459207a (tag: v2.53) ext2: Implement triply indirect blocks
3dbd494f (tag: v2.52) disk: Signature double checking for EFI volume detection fallback
f20457f6 menu: Add option to change the colour of the branding string
db25c748 (tag: v2.51.1) stivale1: Copy the memmap to a bootloader reclaimable region to conform with the spec
dafc710c (tag: v2.51) pmm: Allocate memory map dynamically using EFI
0410e53e cpu: Make rdseed() macro actually use rdseed
411d735e (tag: v2.50.1) Merge pull request #108 from StaticSaga/trunk
62198ba1 fat32: fix LFN ignoring bug introduced by 25e1194
5217f50b (tag: v2.50) pmm: Increase the max size of the memory map
86780fc7 efi: Improve reclaim memory process
b00845fb efi: Add fallback in case we do not manage to pair the boot device handle with a volume
1a71851c disk: Readd readback detection method as fallback
25e11949 fat: Ignore volume label entries in directories. Fixes #107
134fd3c8 disk: Use a different method to match EFI_HANDLEs with volumes
0af91fea disk: Remove bogus pointer
4b724e65 test: Remove hard dependency on KVM
0312020b (tag: v2.49.2) term: Nul should be ignored
12566c53 elf: Make allocation failure simulation more lax
0af1cdb7 (tag: v2.49.1) readline: UEFI: getchar() rework
3d6a1db4 Merge pull request #105 from InsaneMiner/patch-1
c90fa0c9 Update README.md
44da6a1c Update README.md
0562c8ef (tag: v2.49) multiboot1: When on BIOS, set IDTR to BIOS defaults before handoff
605623bd disk: Improve algorithm to determine fastest transfer size
57c44bef Revert "term: Reverse video should not make the cursor invisible"
9d8fd541 Merge pull request #104 from ArsenArsen/trunk
50dcc58a readline: re-add emacs key support
a5def082 term: Reverse video should not make the cursor invisible
31f52c2b efi: Directly use EFI functions instead of using GNU-EFI's call wrapper
23a93a85 (tag: v2.48.1) term: Bug fixes
838c7186 (tag: v2.48) efi: Bump gnu-efi to 3.0.14
16645dfb disk: Misc fixes
483cb465 misc: Add copyright notice at boot
712f4c02 disk: Remove redundant code used to get volume count
9a934eb6 efi: Leave 64MiB to firmware instead of 16MiB
48f7dee6 cpu: Remove static from header inline functions
e497c1d7 disk: Fix bugs introduced by previous commit
04960181 disk: Add logic to determine fastest transfer size
dadca8fe efi: Rework EFI memory map sanitisation
ee3131bd (tag: v2.47.1) gterm: Rearrange logic to determine font properties
cefc4a76 (tag: v2.47) gterm: Implement TERMINAL_FONT_SPACING and default it to 1
f9fe2f96 misc: Bug fixes
1dbc6e39 Merge pull request #103 from Sebastian-byte/patch-1
904488c6 acpi: Fix wrong data type in tables header
fa0aa6d7 (tag: v2.46) gterm: Add config aliases and other minor fixes
3f0c97db Merge pull request #102 from dancek/gterm-fonts
cd02860f gterm: expand font 9th column like VGA
58d128b9 gterm: support font scaling
c11dc238 gterm: rename vga_font_{width,height} to lowercase
a8a8af4c gterm: support different font sizes
867b4a5f gterm: fix custom MENU_FONT
32192f73 (tag: v2.45) docs: Document TEXTMODE option
b2e66e5a term: Misc improvements and fixes
385af687 vga_textmode: Replace BIOS calls to enable and disable hardware cursor with direct VGA port IO
19ecfe9c menu: Fix broken change
7e50f302 term: Fix broken defines and calls
17c5ec43 term: Finish up context control work
0b1c1ccc gterm: Add context control logic
a3f3f95b term: Implement a bunch of escape sequences
1cd381a3 stivale2: More reasonable code flow to determine target video mode
c7a46830 term: Mass backport changes done in Vinix upstream
993a602a (tag: v2.44) term: Support bold attributes
5f1c34a5 tftp: Overhaul and bug fixes
294382e3 Merge pull request #100 from Andy-Python-Programmer/trunk
e308da5b Add the kernel file v2 tag in tests
9798bc2a Merge pull request #99 from Andy-Python-Programmer/trunk
3b4d7c53 Implement the "stivale2_struct_tag_kernel_file_v2" tag
7cca9dd4 build: Misc build system improvements
5ffce7c4 (tag: v2.43) term: Support DEC private escape 25 (enable/disable cursor)
6275457a toolchain: Use program prefix limine- to avoid collisions with x86_64-elf system toolchains
0dde09bb (tag: v2.42) term: Support bright colours
07dc81bb build: Pass -mabi=sysv to cc
5d22de77 term: Misc improvements
7fdacf31 toolchain: Bump GCC to 11.2.0
55411728 Merge pull request #97 from ytret/trunk
059be24d stivale2: set ID of textmode structure tag
241c4dcc (tag: v2.41) limine-install: Minor Makefile fixes
b55c80e2 ci: Ensure dotfiles are copied over to binary releases properly. Closes #96
9540ea62 elf: Make sure KASLR doesn't result in load addresses higher than 0x80000000 for higher half kernels
af28eee1 (tag: v2.40) build: Prevent gensyms.sh from failing if pipefail is not supported by the shell
db561393 stivale: Add requested stack sanity checks. Closes #95
9d68787f build: OpenBSD compatibility
af03050d build: Make build system more BSD friendly
e9760d2e (tag: v2.39) build: Work around gnu-efi build system issue
f2fcc38a stivale2_rt: Fix mov of the incorrect size
5106c6cd test: Update Makefile
5089bafa pmm: Fix sanitise_entries() bugs
2a4f9eb0 (tag: v2.38) elf: Do not enforce segment load address alignment even if PMRs are requested
2bcddaee (tag: v2.37) build: Makefile adjustments
0e2b9c57 term: Bound check when setting cursor position
6e1afcd3 uefi: Initial 32 bit UEFI support
f5b0a4ee (tag: v2.36) elf: More bug fixes
5fa8ef5d elf: Bug fixes
e96b55a4 (tag: v2.35) stivale2: Fix test
de3c7eed stivale2: Implement PMRs
79b8c38c stivale: Initial infrastructure to support ELF permissions
178f3cea elf: Return permission ranges
aec537f5 menu: Fix title alignment
1aa5ae13 misc: Change how bios and uefi macros are defined and tested
d478a1b2 (tag: v2.34) stivale2: Add support for text mode struct tag
f5ffbdf2 stivale2: Add support for any video header tag
63a45e2b stivale2: Implement max_length field of terminal structure tag
f4a47cff gterm: Improve text drawing performance on both QEMU TCG and real hardware
e5ec3c1f gterm: Reintroduce fast canvas drawing, only.
f4dc6481 gterm: Revert recent changes as they make the terminal significantly slower on real hardware
94238607 (tag: v2.33) Revert "readline: rewrite Ctrl-[pnbf] to arrows"
f6662005 Revert "readline: exclude the non-ctrl case from checks"
6f17771c menu: Disable scrolling when displaying status text
50fd990e term: Improve logic of disabling scrolling
ed3c8661 docs: Document RANDOMISE_MEMORY
ffac9b1c stivale2: Prevent buffer overflows when writing to stivale2 terminal
d85e6302 Revert "bmp: Sanity check images"
b5ef61f1 (tag: v2.32) Merge pull request #94 from StaticSaga/trunk
8ea847e5 bmp: Sanity check images
b38b8302 gterm: Fix typo on IMAGE_STRETCHED
0daf11ec (tag: v2.31) gterm: refactor genloop()
cd59bb50 pmm: Add option to randomise memory contents at boot-up
757cc792 (tag: v2.30) menu: Print comments in cyan instead of green
969381c1 Merge pull request #93 from StaticSaga/trunk
cf865fbb docs: Update screenshot
7bfdfbd2 gterm: make gterm_plot_char faster
9f541d2d Merge pull request #92 from ArsenArsen/trunk
2fcabe8d readline: exclude the non-ctrl case from checks
8636aa2f menu: Add support for comments in entry editor
3270ce1b menu: When a directory entry is selected, show expand/collapse rather than boot
00c7c8a6 docs: Document entry comments
3b06a060 menu: Reset terminal palette to default after printing entry comment
2a648329 Merge pull request #91 from ArsenArsen/trunk
9f5c5e09 menu: Support entry comments
9e2d9f16 readline: rewrite Ctrl-[pnbf] to arrows
25d9fd66 term: Do not scroll screen when it shouldn't be
c3f5f0d6 menu: Nicely box boot menu
a39a588b menu: Avoid useless draws of the entry tree
d8db4b17 Merge pull request #90 from StaticSaga/trunk
8a8b4374 gterm+bmp+image: Improve performance on TCG
c284a91d (tag: v2.29) docs: Update README.md
b5f35d60 multiboot1: Make sure all info is passed to kernel in conventional memory
3b18864e (tag: v2.28) efi: Misc bug fixes
0c46de53 Revert "pmm: Use our custom EFI memory entry type to release EFI memory back instead of relying on our memmap"
10e80298 docs: Document stretched background style
393441ad docs: Update attribution of screenshot and testing background
2bce5bf2 docs: Update screenshot
44f5c063 textmode: Minor aesthetic adjustments
0e6ad967 textmode: Fix various cursor-related issues
4d1a02b0 Merge pull request #89 from notYuriy/stretch
6b15b0f9 bmp: Add support for stretched images
177b83de menu: Prefer left alignment for titles which are not divisible by 2
3ba705d0 term: Ensure that double escape character raw prints escape
6b4d5cb6 Merge pull request #88 from carverh/trunk
4c6172d7 Update limine.cfg
8c29063b Centering
6e82bd0e Another Indentation Fix
eb33edf9 Epic last minute formatting fix
05b42b24 Merge branch 'trunk' of https://github.com/carverh/qloader2 into trunk
34825df4 New menu system and editor
a0923688 pmm: Rework pmm_reclaim_uefi_mem()
c2082813 Revert "uefi: Even saner handling of exiting boot services"
ae2d924c efi: Properly propagate exits after loading an image using chainloading; do not try to return from panics if boot services were exited
eadee3e6 pmm: Use our custom EFI memory entry type to release EFI memory back instead of relying on our memmap
e63931f0 linux: Exit bootservices *before* saving the memory map in the zero page
e6cc0e4b uefi: Even saner handling of exiting boot services
05bc7c5b uefi: More sane handling of exiting boot services
d966dc08 pmm: Sanitise raw EFI memory map
4a87babe misc: Forbid variable shadowing
04d713a4 linux: Use get_raw_memmap()
36fa6291 pmm: Optimise get_raw_memmap()
449df1d5 pmm: Implement get_raw_memmap() and use it in mb1 proto
572bcdae x86: Invalidate LDT before handoff
fa2a2d77 protos: Remove dead code
3876645d build: wget -> curl
81f4b869 build: Unify do_32() and direct calls under a single common_spinup()
3b0afa71 build: Ship elf.h for gnu-efi ourselves
08423fb6 stivale: Slight change in how anchors work
591f6012 stivale: Use anchor struct definitions from public stivale headers
84e540ee stivale2: Implement kernel loading by anchor for non-ELF kernels
d62c4f67 stivale: Implement kernel loading by anchor for non-ELF kernels
85a500a6 (tag: v2.27) multiboot1: Fix broken cast
05e7c27f multiboot1: Make sure to load modules at a valid address even when using a.out kludge
d53facc7 multiboot: Load modules right after kernel to emulate GRUB behaviour
04c4c427 test: Update so it builds with LLVM
652a6d25 multiboot1: Reset textmode even if kernel does not request fb info
f294fa1e (tag: v2.26) workflow: Package a Limine tarball that does not rely on version control as well on releases
aee3d962 build: Update version detection method not to rely on Git when a version file is available
b697b6ae build: Build necessary gnu-efi objects in the stage23 Makefile rather than the root one
34584d97 Merge pull request #86 from qookei/trunk
6d47bf9d multiboot1: account for memory that crosses 1MB when summing up sizes
78ec5470 multiboot1: don't mask the PIC when entering kernel
7002918c multiboot1: add a.out kludge support
f84b3365 multiboot1: allocate kernel and modules using proper type
2f08116a (tag: v2.25) misc: Fix potentially misleading strings
f8b5b145 build: Do not fail install if limine-eltorito-efi.bin is not present
7d44e79a build: which -> command -v
52cfc27d limine-install: Implement --force-mbr option
bdc42ce5 Merge pull request #85 from qookei/trunk
6379d059 CONFIG, README: document support for Multiboot 1
e6adc164 entry: accept "multiboot" as well as "multiboot1"
6bb204bb multiboot1: add support for 64-bit ELFs
9115bc7b elf: allow elf64_load to use paddrs instead of vaddrs
22587856 elf: adjust entry point address to paddr in elf32_load
4fb78244 protos: add initial multiboot1 implementation
60e1b43f (tag: v2.24) secureboot: Add .sbat section
ece3e9c0 (tag: v2.23) iso9660: Fix bug where non rockridge filenames were not actually being loaded
7bf53f14 (tag: v2.22) pmm: Do not reclaim EfiLoader sections as usable
eb83d013 (tag: v2.21) disk: Misc bug fixes and improvements
662b5b76 iso9660: Fix improper handling of filename casing
dc47b83c (tag: v2.20) term: Fix various cursor-related issues
abf1d905 (tag: v2.19) stivale32: Fix typo made when converting to AT&T syntax
c31073ce (tag: v2.18) acpi: Fix wrongly calculated RSDP checksum
cebb45ba docs: Fix small typo
ad8620e7 (tag: v2.17) docs: Do not fail to mention how to build limine-install with clang/LLVM too
508e9656 docs: Add instructions for building with clang/LLVM
edf490b8 build: Handle broken or missing mtools
6ac24628 build: Ensure load addresses of debug and tab sections are 0
e69f7429 build: Use linker directly instead of going thru compiler; ensure we are buildable with an llvm toolchain
1e935e10 linux: Fix wrong jmp instruction
6e78e339 misc: Replace Intel-syntax inline assembly with GAS-syntax inline assembly; ensure we can build with clang
87cc5494 build: Remove dependency on GCC-specific -fplan9-extensions flag
18757639 limine-install: Add local .gitignore
bcdf5baa (tag: v2.16) build: Update ISO hybrid creation process
3790d261 bootsect: Also handle if boot drive is above 0x8f and gracefully fail if that's the case
977b00f0 stivale2: Fix bug where when requesting higher half pointers the stivale2 struct pointer was still passed in the lower half
dc3b45a9 term: General terminal improvements
4d7a48ec term: Add support for tabs
a6a88109 stivale2: Unbreak listing tags due to higher half pointers and verbose mode
5176a230 (tag: v2.15) limine-install: Ensure stack is not executable on UNIX/ELF
f9f38f0c build: Revert usage of -mgeneral-regs-only
31ad36ac build: Ensure building toolchain does not fail due to a toolchain not being present already
0602e40c stivale2: Actually pass tag pointers in linked list in the higher half if requested
c940a411 (tag: v2.14) isohybrid: Fix xorriso invocation
d67ce23b stage1: hdd bootsect: Properly guard against image being booted as floppy drive
110d2dc7 (tag: v2.13) misc: Misc EFI-related adjustments
40e65edd (tag: v2.12) panic: Add missing getchar() before returning to EFI
0d3d667b Merge pull request #84 from chocabloc/trunk
e013c2ce include efi.h
60170c9f use fb_clear
9676a3d0 (tag: v2.11) stivale: Load up invalid IDT before jumping to kernel instead of leaking internal one
4737625d fix typo
2c679dce return to firmware instead of halting in uefi mode
eb51e5a1 readline: Fix handling of escape key for BIOS
4c178235 (tag: v2.10) readline: Fix issue where timeouts were not reported properly on BIOS
df6a0d3c (tag: v2.9) readline: Protect against non-printable characters
12ec203f chainload: EFI workarounds
f650e4b4 (tag: v2.8) misc: Add verbose config option
0eb5af44 Revert "stivale2: Reduce verbosity"
b73890cc Revert "stivale: Reduce verbosity"
0687bd27 Revert "linux: Reduce verbosity"
9174a241 fat: Implement FAT12
e228745e linux: Reduce verbosity
8b38bc55 stivale: Reduce verbosity
2526b92a stivale2: Reduce verbosity
3681263f panic: Properly reset palette
26a875c7 build: Do not uselessly create test.hdd image when testing an ISO instead
1a83dfcf (tag: v2.7) misc: Misc bug fixes
8a904b36 docs: Document how to build a hybrid ISO
b48dd898 (tag: v2.6) docs: Document UEFI chainloading
db3a41bc uefi: Implement chainloading support
96b98727 build: Add full hybrid test target
540829f6 disk: Minor adjustments and fixes
08bd3a68 docs: Add donations BTC address
fdfa0207 (tag: v2.5) stivale: Panic if higher half addresses header flag is set for 32-bit kernels
ad2e03b4 pmm: Guard against broken E820 causing an EBDA overwrite
a01e5ecd stivale2: Implement higher half returned addresses flag
4bd3a540 stivale: Implement higher half returned addresses flag
07d9f7d7 build: Bump GCC to 11.1.0, misc fixes
b401d07f (tag: v2.4) build: Work around GCC issue where -static-pie does not seem to work with -elf cross compilers
b7e98a9e docs: Update README.md
ac9ddc7c uefi: Fix linking flags
7750e14c (tag: v2.3.9) stivale2: Preserve state of FS and GS segment registers across terminal print calls
1365d965 (tag: v2.3.8) linux: Make sure to align kernel and modules memory map allocations to page size
f2b172be linux: Pass additional EFI info to kernel
8475f98f linux: Pass EDID info onto kernel
033ceb33 (tag: v2.3.7) stivale: Implement SMBIOS related stuff. Fixes #81
3702060f (tag: v2.3.6) disk: Limit the range of hard drives and optical drives scanned in BIOS
fb7e9fdb (tag: v2.3.5) pmm: Remove dead code and misc bug fixes
6554ff8c (tag: v2.3.4) menu: Fix issue where rescue editor would ignore modifications made when triggered by missing config file instead of lack of entries
f2505f41 (tag: v2.3.3) config: Fix issue where menu_tree would be always NULL
48c6d45c (tag: v2.3.2) limine-install: Turn WARNING about copying limine.sys into a less scary reminder
7f63b9a1 menu: Instead of panicking when no config file exists or it has no entries, offer the user the ability to manually type in a boot entry
b3e4c49e vmm: The PAT flag was accidentally set for 4KiB pages
8c28d8ff (tag: v2.3.1) limine-install: More macOS friendliness
c3db6d0c (tag: v2.3) stivale: Implement KASLR config option
3c0fd2b5 stivale2: Make sure memory at 0x70000 is actually free as per spec
06315dd8 pmm: Protect page 0 of physical memory
8eda1e01 build: Add distclean2 target
4e4017fb pmm: Rework conventional memory allocator
d9466f3d stivale2: Implement unmap NULL using 4KiB pages
5488c881 stivale2: Implement unmap NULL feature
693945b1 stivale2: Implement cols and rows fields for terminal struct tag
e52f4620 toolchain: Bump GCC version to 10.3.0
042c8037 stivale2: Terminal: Save and restore user segment registers instead of smashing them
c011339c (tag: v2.2.6) stivale2: Clear terminal before passing control to kernel
9ab0beea build: Pass -Werror to nasm
d288550b build: Properly handle spaces in PATH
7ac20e06 (tag: v2.2.5) gterm: Many improvements
e402508b gop: Preset mode is the one the firmware gives us
380f358e gop: Do not assume BPP to always be 32
49621f5c (tag: v2.2.4) stivale: Map the framebuffer in the memory map only in stivale protos
4dc24474 gterm: Fix allocated buffer which could be too small and result in an overflow
5434ccb5 gop: Implement missing logic to avoid setting modes when unnecessary
4bbc98b6 Revert "video: Many terminal related bug fixes and improvements"
f7638e96 (tag: v2.2.3) video: Many terminal related bug fixes and improvements
3be90039 (tag: v2.2.2) linux: Ensure that the framebuffer memory map tag does not reach the kernel
f7ab1890 docs: Remove stray ! in README.md
d74e358f Merge pull request #79 from jlxip/trunk
71650253 README: Link to stivale specs
c796764a (tag: v2.2.1) stivale2: Initialise gterm in case we're coming in from a non-graphical mode
ebcaf8df (tag: v2.2) gensyms.sh: Explicitly use bash in shebang
1a7736b2 build: Fix wrong variable used on 'which' invocation in decompressor Makefile
c3481e12 mtrr: Wholly remove MTRR support
91f0600e image: Add support for centering images
bf9962e8 gterm: Speed up terminal by doing sub-character pixel comparisons and only printing differences
8bd7cf74 gterm: Speed up terminal greatly by only printing on screen characters that changed
55a88438 menu: Default to black and grey for bg and fg in case they are not provided for backwards compatibility
05c60bac gterm: Speed up terminal greatly by caching an alpha blent canvas of the background instead of alpha blending every pixel of the background every time
21ec72f1 build: Minor changes
c01a66be docs: Add missing build dependencies to README.md
543edfa0 build: Make build system more flexible to use when using the host toolchain
7e5b809a build: Add missing -pie to test link command
621fc30a build: Prefer -static-pie to -shared for linking PIE executables
9caa5559 trace: Add support for UEFI
46a82f1c test: Add missing break in switch case
7abb7348 stivale2: Implement terminal
4c5ff180 menu: Fix broken comparison that would always override user set menu resolution
bfc613bc (tag: v2.1.6) video: Fix missing terminal deinitialisation before changing into final video mode
98fdd625 (tag: v2.1.5) video: Wire in new textmode modesetting logic; use BIOS instead of VGA ports to enable and disable hardware textmode cursor
49ac7572 video: Implement fb_clear()
1ffb45ac video: Do not switch video modes when unnecessary to avoid flickering and screen blanking out
b44fa6c8 build: Use -M q35 for UEFI test targets
f899648d build: Misc enhancements
e80e20f2 (tag: v2.1.4) Revert "limine-install: Offer the option to force installation on an unrecognised MBR device instead of just failing"
12aceadc libgcc: Fix __udivmoddi4 and __divmoddi4
fc61ae76 (tag: v2.1.3) limine-install: Offer the option to force installation on an unrecognised MBR device instead of just failing
d6f2585b real: Remove stray mov from sleep.asm
235096cb build: Remove now useless libgcc.a references from linker scripts
bc77e657 build: Fix gnu-efi toolchain variables
8e4de054 build: Generally rework build system to easily allow 3rd party toolchains to be used. Drop reliance on libgcc for BIOS builds by shipping our own routines instead
74ef5901 build: UEFI: Link using gcc rather than ld directly, and do not enable PIC
2bdd297c build: Pull actual branch name from git rather than hardcoding 'trunk'
dce8d312 (tag: v2.1.2) stivale2: Report correct kernel/modules memory map type value
59dd147b (tag: v2.1.1) stivale: Refuse to boot if text mode wanted on UEFI
383dd5ae gh: Automatically update latest-binary branch in workflow
012d0627 docs: Update README.md
2f299b1f test: Update Makefile
de87ced0 gh: Do not base binary branch names off minor release names
0f0dddf7 (tag: v2.1) part: Harden MBR detection code
25bba4ec docs: Update ISO creation commands in README.md
bd0a713c bios: Skip disks which return bogus geometry
38bbc1ea makefile: Use xorriso and add pure UEFI ISO test target
0885bac3 stivale2: Implement kernel slide tag
c45407cb test: Remove KASLR entries from config since that is no longer an option
d1946b9d stivale2: Implement kernel file tag
61f518b8 docs: Update CONFIG.md
fc0dc17b stivale2: Remove useless KASLR related code
23bf225f test: Apparently manually defining PHDRs is not actually needed
30b750a2 elf: Always do ASLR when loading relocatable ELFs and handle unavailable memory ranges instead of crashing
621a004b menu: Make right arrow act as enter on entries
0579a19d (tag: v2.0.1) build: Create limine directory inside share directory and copy over LICENSE.md to binary releases
04bef1ce (tag: v2.0) misc: Warn about missing limine.sys only when necessary
eaeab80c misc: Update documentation
af53421c fb: Support 64-bit EFI framebuffer bases
698e386c misc: Add warnings about copying limine.sys over
48e6d8f9 echfs: Remove overly verbose print
b20c4402 linux: Remove overly verbose print
5543f609 (tag: v2.0-rc8) build: Ensure that limine-eltorito-efi.bin gets rebuilt when necessary
c89644b3 edid: Properly get segment:offset from flat address
2dc49ee7 vbe: Force bpp to 32 when trying EDID else it will never work
984986a6 iso9660: Add support for rock ridge and properly handle padded sectors when searching directories
cd3a64c9 (tag: v2.0-rc7) linux: Initial support for 32 bit boot protocol instead of 16 bit one
0cc0e019 build: Also remove limine-install.exe in limine-install Makefile
97930647 (tag: v2.0-rc6) build: Properly handle when limine-install is suffixed with .exe
0efa2e16 build: Add install target to limine-install Makefile
84c41d38 limine-install: Fix mingw external references
a4680718 gh: Workflow needs mtools
37a40880 protos: Fix retf frames for Linux and chainload
495e1a13 limine-install: Also zero out secondary GPT header
2e12cc0a protos: Make sure Linux and chainload protocols use the proper real mode IVT when spun up
17c184ca limine-install: Zero out partition entries BEFORE calculating crc32
0a1dfa76 misc: Move limine-install to own directory and provide source and Makefile for it in binary releases
f6aab27f limine-install: Zero out unused partition entries
e374d732 pmm: Fix bug with memmap_alloc_range() where the type of the new upper entry was incorrectly set
32121555 iso: Generate eltorito EFI boot image
f7dc2e7b (tag: v2.0-rc5) pmm: Limit bump allocator to 0x70000 on UEFI as well
fd66a943 gop: Change way preset resolution is set when fallbacking
1b1b014a pmm: Misc bug fixes and improvements
741dca50 misc: Fix linker_dbg.ld section misplacement
b71e3a0a (tag: v2.0-rc4) misc: Fix LIMINE_VERSION
4cd8e00a gh: Update gh workflow
39936f59 fb: Improve fallback resolution logic
6bbc31f2 disk: Actually wire in the max_partition logic
0bdc5da6 gh: Update gh workflow
91e4e651 (tag: v2.0-rc3) gh: Update gh workflow
503fb92c config: Update search paths
8b8b7841 gh: Update gh workflow
6c7e0968 stivale2: Implement EDID and EFI system table tags
3674ce3a gop: Implement fallback resolutions like for VBE
d6cda61f gop: Properly determine bpp and pixel masks and shifts
7950ac59 uefi: Add hacky support for determining boot drive was a CD
094c8eca protos: Properly advertise the presence of PXE to stivale2
1f1f601c pmm: Make sure conv_mem_alloc() does not return NULL as a valid allocation
05f60916 (tag: v2.0-rc1) gh: We don't want draft releases anymore
441c6fad misc: Makefile fixes
9386536c uefi: We don't do PXE
7ee7e342 pxe: Make it work again
de4fd786 uri: Replace bios:// with hdd:// and odd://
1a1be5b0 misc: Add FAT16 to the supported filesystems in readme
5380c82e fat16: FAT16 does not use the high sector number in the directory entries
18228395 fat: Initial FAT16 implementation
23838a4e misc: We don't stacktrace on UEFI
63bccd9b misc: IDT itself does not need to be in .realmode
94887a45 misc: Handle CPU exceptions nicely
9e60b1da misc: Split off a stage 2 symbol map and embed it into stage 2 so that it can print stacktrace symbol names before stage 3 is loaded
6d9d3259 stivale: UEFI is not BIOS
12d58228 misc: Add pxe-test Makefile target
53332d70 misc: Clean up the boot device detection system
0cd183fa misc: Make sure Limine UEFI still works without GRAPHICS=yes and/or with TIMEOUT=0
7f32fb59 mtrr: Fix range overlap check
8bcbaa48 stivale: Exit boot services in the right spot
ab441fec acpi: Fix length of RSDP calculation
0ab68fa8 pmm: Remove useless if
6fe0a46a pmm: Implement pmm_reclaim_uefi_mem()
781fc313 misc: Revert test limine.cfg
bd69732b misc: Make sure 64 bit Linux binary limine-install also gets statically linked
3e9eee3b misc: Update gh workflow
0bd4e297 limine-install: Add relevant mingw code
271ac851 misc: Makefile fixes and update README.md
32aa82a1 misc: Fix output of limine_stage2only.elf in Makefile
db20cc75 misc: Disentangle Makefiles so it builds fine with -j
a8626d6f misc: Initial Makefile rework
62b042a2 Get SMP to work on UEFI
058da701 Misc fixes
e56df5b3 pmm: Make conventional memory allocator work with UEFI
4e55d287 acpi: Implement UEFI version of acpi_get_rsdp()
d96bdf77 fat32: Fix base calculation for cluster sizes of more than 1 sector
5d3f8b4e Implement do_32() and make stivale kernels work with UEFI
6c22743c Do not build necessary gnu-efi dependencies using the host compiler, use our toolchain instead
249d0589 limine-install: Fix buffer overflow bug with new stage 2 alignments
32a45393 iso9660: support files without extension
443266fe Implement UEFI EDID
c3c278ff Always use our own (better) allocator
a81f094d Implement UEFI to Limine memory map conversion
8939c342 misc: Compile stage 2 with -Os and stage 3 with -O3
cbcf3779 Fix keyboard stuff
5dc8f48d limine-install: Make sure stage 2 chunks are sector aligned
f26b6045 Let there be GOP
c478e57a Tidy up stage 3 entry
deac1d7f Misc stuff
7be0b35f We got the config to load
1be84baf Makefile fixes
746d9146 Make the smp trampoline more UEFI friendly
82466973 Implement disk_volume_from_efi_handle()
e21b9d87 Fix sleep_and_quit_on_keypress on BIOS
f7a8bbd7 A lot of changes
54862a82 disk: More properly detect non-present removable media
3e4b4a6b disk: Move caching code to part.c from disk.c
0ec05371 Make it work
7d8758d6 Further Makefile fixes
7f2c1743 More Makefile fixes
6d756cf7 Makefile fixes
edd4a8de Initial UEFI port
a7a168a6 fb: Abstract framebuffer API
689e82db vbe: Move graphical terminal code to gterm and ship font instead of dumping from graphics card
d4ea15e3 misc: Make sure to remove limine_stage2only.elf in stage23 clean target
71d0feb2 tinf: Remove legacy stage 3 stuff
8c0c36ea misc: Change the way stage 2 and 3 are divided
659a6afa iso9660: Fix GCC 11 'array subscript partly outside array bounds' warning
1e7ba952 config: Move config code to stage 3
60742ea6 main: Add missing switch case for CD boot
c2cbddb3 misc: Reorganise docs
8769aaae misc: Move a lot of code from stage 2 to stage 3
08f6ea60 misc: Add measures to prevent stage 2 from accidentally relying on stage 3 before the latter is loaded
bd8c9ed6 misc: Add a build ID to make sure that stage2 and stage3 always come from the same build
f5227efb misc: Update README.md
741d749e makefile: Install bootloader binaries to share
573616d9 misc: Update README.md
7e786cee misc: Misc adjustments
8ff991f1 Merge pull request #75 from jlxip/TomHangs
00dbeaa8 stivale2: fix stivale2_load parameters
c8e78708 Merge pull request #74 from jlxip/supermonkey
7677c610 iso9660: back to stage2+decompressor
75647aa9 Merge pull request #73 from jlxip/rerevert
1a5cb00c iso9660: Root caching (rereverting)
326bcbfa misc: Misc adjustments
27848fc8 misc: General code reorganisation
7eb22e5c misc: Remove binaries from repo
20055d3e misc: GitHub workflows test run
06739628 misc: Code reorganisation
06476eb3 Merge pull request #70 from jlxip/caching
d9a4d3a6 iso9660: Root caching
2e408741 iso9660: Bug fix and move to stage 3
60a3fab2 Merge pull request #69 from jlxip/final2
34460c31 iso9660
8141ff54 misc: More Makefile adjustments
81f39417 misc: Makefile adjustments
6739ff84 tinf: Do not share decompressor and stage2/3 decompression code
96054937 misc: Fix makefile clean targets
52482937 misc: Initial 3-stage bootloader work
5d75f521 Merge pull request #66 from jlxip/unstable
ddcbfeb4 limine-install: Initialize lb_size so GCC doesn't warn
89840776 fat32: Fix bug with conversion to 8+3 filename
c373a734 misc: Bump binutils to 2.36.1
02485391 ext2: Change line endings of source files to UNIX
e3d59254 volume: Replace concept of partition handle with that of volumes, fix bug in indexing volumes along the way
1e80f131 linux: Misc protocol bug fixes
81a134b5 linux: Misc protocol bug fixes
5e344a54 misc: Bump binutils to 2.36
b913ecbf sleep: Do not clobber int 0x80 for PIT IRQ handler callback
cae6298d guid: Add handling of mixed endianness GUIDs
042a377e misc: Bump stivale commit
0bc87d66 misc: Make build system download stivale headers from stivale repository and delete local copies
3184e0a0 misc: Update warning about unstable branch in README
9363b8c4 misc: stivale specifications moved to stivale/stivale
bb7030d3 misc: Add binary architecture flag to objcopy to avoid limine-install build failures on older host toolchains. Fixes #63
ef4dfdd4 misc: Update example version of limine in readme
5b8132a4 fat32: Fix wrong return type issue
7674fa6a limine-install: Fix argument order for strstr() call
57496ad0 stivale2: Implement MTRR Write Combining Framebuffer tag
b63fad76 stivale: Clarify some parts of the specification and add bootloader reclaimable type to the memory map entry enum in stivale.h
780c0314 file: Make sure is_memfile is properly cleared
717af1ff file: Make sure file buffers are aligned and of the right type
79a9f31c file: Add ability to rename memory regions for memory loaded files so they do not have to be allocated twice for things such as compressed module loading
7a0777d7 misc: Update link to echfs repository
5d1f87d0 limine-install: Misc adjustments
edbc127f limine-install: Add _FILE_OFFSET_BITS macro to ensure off_t is 64 bit
cdee80d5 limine-install: Sanitise error handling
5c16ea17 misc: Update screenshot
9b620360 misc: Update copyright year
821bc2c0 misc: Update binary images
f90dbd93 Merge pull request #62 from Matt8898/unstable
f5c3b494 Fix gzip code.
747d8a9c misc: Update README
4b86708f misc: Minor makefile dependency fixes
51972056 limine-install: Embed limine.bin inside limine-install
18bfa311 misc: Replace conv_mem_alloc() with ext_mem_alloc() where it made sense to do so
366d75e7 misc: Remove limine.h and retrieve LIMINE_VERSION value from current git branch instead
7f1dd088 limine-install: Only perform physical block aligned reads and writes
4e23f005 uri: Make boot resource be an alias of tftp of booted off PXE
3f397141 config: Search for tomatboot.cfg config files as well
ed0212bd misc: Update binary images
a3a418b7 Merge pull request #59 from N00byEdge/hyperv-ipi
0cfb67ef Set the 'level' flag when sending Init and Startup IPIs
0c96d0a9 misc: Clarify config docs on E9 and COM1
b12e8745 misc: Support COM1 debug output
fcd3848a elf: Fix bug where slide was not added to entry point address
4bebeba6 kaslr: Update documentation
8bb0db92 rand: Fix allocation bug
1f10b55b stivale: Make kaslr a config setting
5bc1e8d8 misc: Remove compressed bg
13f3ee09 misc: Make sure relocatable kernels work
faae7a00 vbe: Fix bug where the vbe tty double buffer did not properly refresh
a9ff406d uri: Add support for gzip-compressed files
9bff739d limine-install/gpt: Fix broken comparison of partition count and print out partition count when embedding
34ddbe6f part: Add support for MBR extended and logical partitions
0daaa565 misc: Update readme and screenshot
57360b15 menu: Add support for home and end bindings in textbox
1f0636bc limine-install: Fix type mismatch bug
ac08fbc5 menu: Report to the user when text buffer is saturated
1281a24d menu: Gracefully handle long lines wrapping in the textbox
09ae5a21 panic: Go back to real mode instead of hanging with interrupts disabled so BIOS can handle events like ctrl-alt-delete
675e73e7 menu: Small cosmetic changes to textbox
b5bca983 menu: Implement prettier entry edit textbox which handles scrolling
9538d620 menu: Cleanup way escaping editor is handled and check for \n instead of \r in main menu
22ba144d getchar: Return \n when return is pressed instead of passing through \r from int 10h
b8e580b1 limine-install: General code cleanup
50541a7d Merge pull request #57 from Matt8898/unstable
c5eebbd9 pxe: add stivale2 pxe server info tag
18992d92 (tag: v0.7) docs: Explicitly state that the bootloader may ignore kernel header tags in stivale2
3d76435d stivale: Make bootloader reclaImable entries aligned by spec
ed939eb6 docs: Document MENU_BRANDING config key
cdfc454a menu: Support changing branding title screen
0a8eae7b uri: Make 'uuid' an alias of 'guid'
08d53bff part: Implement unified namespace between GPT partition UUIDs and filesystem UUIDs
7545864f misc: Bump version to 0.7
8c910b20 uri: Add boot resource
9c529853 misc: Update binary images
ead1136c Merge pull request #56 from limine-bootloader/embedded_gpt
475abd60 misc: Revert binary files to unstable's state as to make the PR mergeable
eeb647d0 limine-install: Add more sanity checks and give the choice to install stage 2 to a partition with GPT
d40a6a36 font: Specify that we use code page 437, use unsigned 8-bit fonts and special characters to print the menu's tree
35181c2b gpt: Embed stage2 code within GPT structures so an extra partition is not needed
8d04ab1c vbe: Add support for user loadable fonts for the menu
34138387 docs: Document sub-entries and default expanded entries
6ab44cb0 stivale: Add support for extended colour information
2f486fae elf32: Fix bug where vaddr was used for memory zeroing instead of paddr
b75b35c5 fat32: General cleanup and optimisation
3ee1ee88 menu: Fix bug where variable may be used uninitialised, make DEFAULT_ENTRY 1-based, add 'no' setting for TIMEOUT
fe022c49 menu: Do not have countdown if default entry is a directory
75c51c1e misc: Update binary images
60b72aee Merge pull request #55 from N00byEdge/pxe_smaller_packets_fix
78b19f87 Add built binaries
0c81b639 Don't stop download if tftp server sends packets smaller than the negotiated mtu
99aaceda linux: Allocate the relocation buffer for the command line early so it's allocated before the real mode code
a9d69d38 linux: Fix issue where command line buffer might be in memory in an address outside the range the boot protocol mandates
4c09663a menu: Fix issue where command line buffer was allocated in conventional memory and subsequently discarded
9b7f9e42 config: Add default expanded entries
8c4f3ecf misc: Make distclean Makefile target actually clean everything
e7147188 vbe: Fix handling of VBE versions older than 3.0
c0417a87 config: Dynamically allocate buffer for config values when requested
81b99116 pmm: Panic if there is an attempt to reserve a memory range below 1 MiB
af78abb1 pmm: Fix bug where align_entry() would return the wrong error value
9cd21c6a term: Add double buffering
ed590257 misc: Reuse buffers that hold the paths of module files for protocols
a8a07942 config: Add full entry editor
6cdae13b makefile: Make test targets depend on all
536a8262 panic: Do not print stacktrace if map file is not loaded. Fix places where we erroneously appended a newline to a panic string
85b4d063 menu: Prettify print_tree()
dc54ee97 config: Add initial support for config directory entries
970b4e3f misc: Fix a bunch of warnings related to potentially used uninitialised variables
873ebc38 Merge pull request #54 from Matt8898/unstable
1e0ed9aa Add pxe documentation.
f2d40775 Update issue templates
c33d6c1d misc: Document STAGE2_MAP config key
6fd8eb05 ext2: Add initial symlink support. Fixes #53
7b6fe03a misc: Upload stage2.map
8460cee5 misc: Implement stacktrace
36b5be13 pmm: Only align memory map when explicitly requested as not to fragment ext_mem allocations too much
769ab76e ext2: Improve performance of non-ext4 inode reads by caching the block chain
754f1a35 ext2: Fix bug where tokens were not appended a 0 terminator when examining path
352f74da stivale2: Fix bug where uri_open return value is tested wrong; uri: Allocate new buffer on uri_resolve
e3519a6c (tag: v0.6) misc: Change config location detection mechanism slightly
92814b47 misc: Rename master to unstable
98c8921a misc: Update background and screenshot
168716a2 misc: Add config file options for specifying the resolution in a granular way. Other misc bug fixes. Fixes #45
495b1570 vbe: Ensure that the format is xRGB8888 for the graphical menu
cfb1734f vbe: Implement more expressive framebuffer tag (fixes #37)
6d232193 stivale: Fix pagemap not mapping every memmap entry bug
13900624 linux: Add possibility to load multiple modules
03413047 CONFIG.md: Add missing color to list
ceb51518 misc: Remove 512-byte sector assumptions from various places
1ead86ef bootsect: Do not assume 512-byte sectors
dbb88b59 Update CONFIG.md
65b39a41 menu: Make theme colours a single key
f0172ee1 blib: Make strtoui return the address of the first non-numeric digit
1ed98572 Merge pull request #50 from Matt8898/master
e7ae1953 Add pxe support
10bd2696 blib: Make strtoui break on first non numeric digit
d7ec93d0 bootsect: Move jump to stage2 to second half of bootsector
d799658b bootsect: Remove useless instructions
48a9d06a blib: Update strtoui
82a71514 part: Some general cleanup
c542ff68 Some general cleanup
0319b51b Use URIs in the last few remaining places, update CONFIG.md
bacef9fc Add warning about using master branch to README.md
038c0412 Add GUID resource type
28c1538f Bump version number to 0.6
569df8ac Use URIs everywhere, update config documentation. Fixes #48
849d05c7 Add missing config keys to documentation. Fixes #47
1de57494 readline: Support delete key
530b4a8f readline: Initial implementation
b8b7a798 LAPIC: Fix bug where wrong CPUID bit was tested to check for APIC
07ac3de4 SMP: Fix struct duplication bug
b7f44129 Add BSP LAPIC ID field to stivale2 SMP structure. Resolves #46
7867d23e Fix bug in elf lib where a very large buffer could be accidentally allocated on the stack
01399b2e stivale2: Adjust the SMP part of the specification to mention that the BSP ID is not guaranteed to be 0
e8f1c943 Change return type of cpuid(), add APIC existance check, do not assume BSP APIC ID to be 0
2b34d88d Remove instances in which conv_mem_alloc() was implicitly used as a realloc() as that subtly introduces bugs
74c7c0d7 Add E9_OUTPUT config option
54eaf968 Remove conv_mem_rewind() as it could be a dangerous source of bugs, modify code that used it accordingly
0e09a892 BIOS disk driver: do not make assumptions about sector size being 512 bytes
a82dc582 Add BIOS drive indexing
a9864a0a Implement string_to_guid()
47d517be Use URIs instead of explicit drive and partition keys in config file
7863c92c Add URI parser
0c5ccf14 Remove eccessive memmap dumps and add stivale and stivale2 module loading feedback messages
de0f0da1 Move A20 handler out of bootsector and into stage 2
1d7cc0ee Bump binutils to 2.35.1
2aed1313 Move cpuid() to cpu.h
513d0a22 Extend x2APIC check as per VT-d specification
c778e72a Fix up make clean
44f97d9f Add --enable-64-bit-bfd flag to binutils configure so that build does not fail on 32-bit hosts
c913a7cc (tag: v0.5) Fix up some inline assembly in sys/cpu.h
d9b06291 Fix all warnings and add -Werror to CFLAGS so people stop committing broken code
d9e40a7d Move kernel file code where it belongs
53339c80 Merge pull request #42 from ethan4984/master
2a084c47 vbe: Properly handle a value of 0 for THEME_MARGIN_GRADIENT
74572cf6 Update Makefile
806766aa protocol code clean up
333270a3 Merge pull request #41 from Matt8898/master
7f5fcad2 Fix wrong sizeof in the ext4 bgd branch
3c562830 pmm: Merge contiguous bootloader reclaimable entries
5f003858 Update screenshot to have Windows 10 instead of Gentoo
20d19b6a Update screenshot
1ea09891 VBE: Add margin gradient
53eb16b8 Merge pull request #40 from streaksu/master
7d400d30 Add a unified test image for stivale1 and stivale2 for both x86_64 and i386
b171d8fb Merge pull request #39 from Matt8898/master
605879e8 Split ext2 and ext4 bgd
b775e086 Merge pull request #38 from ethan4984/master
2eac51b6 Update Makefile
cb55d3be missing stdio
2f7d3c37 Default back to text mode instead of VBE, add DEFAULT_ENTRY config option
562e3c7c menu: Do not ignore key pressed during countdown
fed66450 MTRR: Add cpuid mtrr feature check
c3570f9f Merge pull request #36 from N00byEdge/patch-1
f49fad13 MTRR: Fix bug where 2 ANDs should have been ORs
98c5b88f MTRR: Ensure size of MTRR range is aligned to the closest power of 2
3888b1ce Fix struct names
0cfb40b5 Stivale2: Add MMIO32 UART and Device tree blob tags
86a69d87 Add write-combining and MTRR support to speed up VBE framebuffer
e886a6fa stivale2: Finish implementing x2APIC support
b830c71d VBE: Pass struct char around by pointer instead of by value
3c3a132e Some VBE optimisations
b733ef25 Fix stivale2 SMP tag issue
a58fd6bd Fix stivale2 SMP tag issue
0dc73b35 Fix conv_mem_alloc bug introduced by e721c3c
11240b59 Fix potential memmap circular dependency issue
0403a29f Refactor VBE code
f4f4c589 Update CONFIG.md
5457af42 Minor fixes to Linux and Chainloading protocols
2483902b Merge pull request #35 from sleepy-monax/perffix
134266da Fix performance issues introduced by #33 in the vbe code.
b41fa7e2 Fix bugs related to handling real mode switch in inline assembly sections; reenable LTO as that fixes it
c657e86c Move stack to 0x7c00
ef56c296 Update README
ff967cf3 Update screenshot
ed5d049c Fix issue with int 13h DAP potentially not fitting within a single real mode segment; load stage 2 at 0x8000 and disable LTO as it is broken for some unknown reasons now
d192bb91 Merge pull request #33 from sleepy-monax/master
4f6b1d20 Made the margin configurable.
d6f16297 Added alpha support.
0477d342 The color scheme can be changed using the configuration file.
9a9df2b1 Merge pull request #32 from Matt8898/master
67591e6b Fix ext2 warning
0d7754b3 Update limine.bin
296d918c Merge pull request #31 from Matt8898/master
f758d100 Add proper support for 64 bit ext4
ed5c214c Make graphical background a frame around a centered terminal box
7aa9d845 Complete background infrastructure and fix some bmp bugs
5ee53fbe Initial work on bitmap and background support. Add a public domain picture.
06e7f907 Update markdowns
41e03713 Fix vmm warnings
be3d60ec Fix warnings and build issues and update binary image
6320126e Merge pull request #30 from Matt8898/ext4
81faf039 Add ext4 extent support
c869ab6f Add header dependencies to Makefiles
f245d0e2 Reorganise headers
e721c3c8 Reorganise pmm code
f59a3d67 Change how smp works a little
6c0ba410 Default to graphical mode for the menu
d3bd6282 Make extended memory allocator allocate top down and mark the allocated areas as bootloader reclaimable
4927abcf Adjust stivale2 SMP spec a little to add an extra argument to the smp_info struct
c3c3c5dd Fix broken struct stivale2_struct_tag_smp definition
10ce8e07 Do not align allocations in init_smp
132ff2fd Fix bug where identifier is not set for SMP tag
6591a9c3 Fix some warnings in the decompressor and do not use special symbol main() for entry points
8410abb3 Build gzip and nasm as part of the toolchain to ensure reproducibility
73fa01d1 smp: Fix bug where started APs would not be aware of 5-level paging
927851e2 Update README.md
c2bf4835 Add sys/ directory to stage2
dbf38b76 Rename processor_id to acpi_processor_uid and other minor bug fixes
8b37fe66 Finish implementing SMP
845889d7 Merge pull request #29 from sleepy-monax/master
066aa151 Added stivale mmap struct.
41c68e5e Initial SMP implementation
fc51b7e0 Merge pull request #28 from sleepy-monax/master
9f0a2c60 Move stivale in separate headers. Making them easier to use when including "limine" has a submodule. Also renamed stivale2_hdr_tag_framebuffer to stivale2_header_tag_framebuffer. This make it more consistant with other declaration in stivale2.
9c10b5d5 Merge pull request #27 from sleepy-monax/patch-1
2524f0d0 "make clean" was not removing limine-install.
3c790f98 Clarify the stack situation in stivale specs
8271c0b8 32bit stivale was not pushing a return address. (#26)
79fb7342 Fix bug in 32-bit stivale
4bda00b6 Implement acpi_get_table()
a909fd82 Some work on ACPI and use EBDA start as end of usable conventional memory
a7980f3d Some fixes and tweaks in the Ext2 filesystem (#25)
1bb1bd22 Revert to -masm=intel for inline assembly
e7838e85 Revert back to not baking the bootloader into the limine-install binary
1ddf5682 Further tidy up Makefile
cb9edd2a Reorganise source tree
6a6171d5 Update README.md
ccbba7ee Remove now-useless libgcc functions from builtins.asm
dd6f38f6 Ship reproducible prebuilt bootloader and make 'make all' only build limine-install
5663169a Switch back to GCC
859a10b1 Update stivale specifications
2e537412 Improve the way stivale paging is set up
1ccf8e34 Adapt new vmm to 5-level paging as well
0c7e08d3 Add a more proper 64-bit vmm
9802c8d3 removed stray libgcc (#24)
ef6ef586 Implement support functions ourselves instead of relying on libgcc
c5312251 Make the test image smaller and align the partition properly
97394ff6 Fix limine-install issue where it did not copy over MBR timestamp and disk signature
8760c0b3 Add protective BPB in bootsector and check for the presence of int 13h extensions before using them
b16f6345 Shuffle around memory layout of bootloader
45aaa72e Decompressor (#23)
734a3e26 (tag: v0.4.1) Fix stivale2 memmap struct being misdefined
7bde0c80 (tag: v0.4) Move to clang, no longer ship prebuilt binary, embed bootloader into the installer and provide a way to install the installer
ea62cf37 Fix alignment issues with memmap and modules in stivale2
4ac886b2 Add limine-install as a dependency to test targets
ba7ed52f Enable lto and move naked assembly functions to own files
53797879 Only enter graphical terminal mode for menu
902109ef Wire up logic for graphical terminal
3eb7d5f0 Implement logic for graphical terminal
2052d92b Implement ext_mem_balloc()
46f46ddd When calling into real mode, also pass the segment registers
b9be2e70 Change PIC IRQ flushing method
1a267656 Add Clang compile instructions to readme
866e95b4 Rebranding
2150daaf Fix bug with clobbers of cpuid function
15536257 Reimplement memcpy, memmove, memcmp, and memset in assembly to work around potentially buggy compilers generating references to those function recursively within the function bodies
e2a87ca3 Fix handling of return value for strcmp and strncmp
fc23258a Handle intel style inline assembly via macros for compatibility with clang, remove TempleOS protocol support
b2d24ecc Update binary image
45033e81 Better firmware compatibility. (#19)
97b8d367 Force IPV4 in toolchain script (#18)
008b6e69 Mark the partition as bootable (#17)
c97fc83b Fix up compile flags
f67f022d Bump binutils to 2.35
a223f9c3 Update STIVALE2.md
a002f051 Fix broken memory types in stivale
6296d27c Restore old stivale specification and move stivale2 spec to own file
9fcb13c2 Tagging stivale (#16)
32278a69 (tag: v0.3) Add reference screenshot
6d349d80 Bump GCC to 10.2.0
ddd4172d Add memory clobbers where missing and remove useless stivale signature
e45f8ac4 stivale: Zero out unused GPRs and add a signature
1bbe7f93 FAT32: fail if computing the 8.3 filename goes wrong
bb96bab7 Fix another FAT32 bug (introduced by me)
6d5efbdc Make test cases buildable on FreeBSD
e7669cad Fix config bug (2)
78d1b8a8 Fix config bug
21490a84 Teach qloader2 to handle windows line endings
8ac26c40 Fix fat32 bug
94ff47ea Fix issues in qloader2-install.c
43918c96 Add C version of qloader2-install script
bf86dbd5 Fix bug where BIOS flag was not set in stivale, add TempleOS to list of supported boot protocols
5a263059 vbe: Add fallback resolutions
2e96f8fe fat32: Fix handling of non-lfn files
22ac7908 Add support for TempleOS boot protocol
925631cc Fix bug in FAT32 code
9f5baf2f Fix markdown issue in stivale spec
e658faff Adjust stivale spec
d8b9a2bb Rework memmap
dddfe438 Make memmap less verbose
5a6d6afb Fix bug in memmap and vga textmode
c05c6520 Add more verbose memory map logging
ab1e8710 Rework boot menu
24ddd20e Handle improper file paths (#14)
b616e801 Sort memmap entries
e91cb822 Added improved memmap
3d75644e Add a call to BIOS int 15h AX EC00h before entering Long Mode in stivale proto
7336f2b8 Increase randomness quality by adding rdseed instruction support
42906fef Add a more proper rand implementation
045c4078 Update binary image
df4931e2 Merge pull request #13 from N00byEdge/fixstacksmash
359cdb08 Fixed stack smashing with fread()
b08abed0 Fix segment register issues in pit_sleep_and_quit_on_keypress()
4947a845 Make sure to mask and flush IRQs for stivale protocol
9fbfb676 Update copyright notice
65402390 Add possibility to pick separate entry point to stivale
e427ab4b Update binary image
c79817ee Merge pull request #12 from N00byEdge/kaslr
6dd399ea Add KASLR for PIE ELF files when using stivale
bb642c19 (tag: v0.2.6) Fix config entry parsing issue
ef122f65 Add BIOS/UEFI flag to stivale spec
ed8e7b96 Add support for chainloading another bootsector
85a41066 Update binary image
5738dc06 Make config allocation dynamic
73608512 Update binary image
b52a6fd0 Make panic a formatted print
ed1fb650 Move print stuff to its own file
b7cd5378 Update GCC to 10.1.0
dfea9ac4 Save the GDT when hopping to real mode
14fc5f82 Update binary image
2a276dc2 Make 16 bit GDT entry limits 0xffff
40a63ecb (tag: v0.2.5) Initial chainloading support
35376681 Update binary image
389b6879 Change how config works a bit
23ba6bdb Fix type mismatch issue in ext2fs driver
00e313d0 Add 5-level paging support
cffdc2f0 Add checks for get_part errors
62d78d1f Add out of memory checks
adb083e1 Add Discord server invite to readme
e077ac9b (tag: v0.2.4) Update binary image
0dc17a97 Merge pull request #9 from KrekBuk/master
3084b81f FAT32: improve non-fragmented files read times fat32_read now looks for non-fragmented chains to load large files in single read_partition call which should improve performance for reading larger files.
b842720a FAT32: support directory entries larger than 1 sector There was already a support for partitions with bigger cluster sizes but there was also a bug where the directory loading code would only look  at the first sector of each cluster and could incorrectly report some files as non-existing.
6175e728 Add FAT32 to list of supported filesystems in readme
d9eb0b40 Add partprobe to test targets in makefile
d1d46295 Merge pull request #8 from KrekBuk/master
af1b908d FAT32 support
e3dbdad6 Align disk buffer to 16 for perf reasons
2ec27cbe Dynamically allocate e820
96f8c65f Fix bug where eax was trashed in pit_sleep_and_wait_for_keypress()
8db7cdcb Add time stuff
6ad7df10 Add long mode checks
8e7ce7a1 Dehook int 0x08 when unused
f8c0b317 Resolve most GCC warnings
45bae801 (tag: v0.2.3) Update binary image
09683cc5 Hook bios interrupt 0x08 instead of 0x1c for PIT ticks
2fd36507 Rewrite pit_sleep_and_quit_on_keypress() to be fully in real mode to avoid issues with switching back and forth
8ef1e28e (tag: v0.2.2) Misc bug fixes and sanity checks
2c3bd468 Fix bug where config file values with a colon were interpreted as entries (3)
2b6cf629 Fix bug where config file values with a colon were interpreted as entries (2)
7904025c Fix bug where config file values with a colon were interpreted as entries
ebae7c91 (tag: v0.2.1) Change default optimisation level to -Os and update binary image
b479d69c Make VGA textmode deinit reset video mode with BIOS
5e9adf35 Make libc functions more standard compliant
ee38f8b4 Improve ext2 inode reading
bcfd9e5f (tag: v0.2) Add definition of memory map to stivale spec
312cc56a Add draft of stivale specification
8be6ea8a Fix ext2fs bug
2fc3b212 Use int 0x16 for pit_sleep_and_quit_on_keypress()
d314bd84 Update binary image
38e18917 Update README.md
633d49b7 Fix issue where cmdline is not loaded
bc7f7277 Reorganise ext2 directory code
d7c6aa5a Fix ext2 bug
b1c305ab Added ext2 subdirectory support (#6)
55137edb Add CONFIG.md
f153e1a5 Update binary image
15c18d76 Add boot menu
725a1fc1 Add parsing of config entries
fb827cb5 Make qloader2-install less verbose
41ea91c6 echfs: Add directory support
f32bea51 Update README.md
97ec3db6 Update binary image
9fa35d34 Implement deinit for VGA textmode driver
9beda4af Initial linux protocol support
9358a4fe Optimise echfs file loading by caching allocation map
6a9c5f3c Update binary image
5f859ea7 Add 32 bit stivale support
7ae67812 (tag: v0.1) Handle if EDID returns resolution of 0 and update binary image
0a3f00f6 Fix ext2 driver
9038e3b8 Update binary image
bb19074e Fix ext2 driver
5d0c6d92 Improve ext2 driver a bit
87876de2 Update binary image
8680f99e Add GPT support
98086e38 Add option to change where stage 2 is located
609f9d86 EXT2 and VFS support (#5)
54711211 Update binary image
d2c4773c Add file handle abstractions
680d683c Remove echfs caching due to memory constraints
f4522ba5 Add panics on failed allocations
3a4ec45e Fixed EDID bug
375bdc6c Fix makefile
df22bcc1 Add readme and prebuilt image
2ecd4a80 Make stivale actually pass the command line to the kernel
6578b55c Add module support to stivale
babc5269 Make config more encapsulated
84ac9643 Add bump allocator
44a5f475 Add timeout config option
a234da8d Add bpp field to stivale header
e39d7f5d Ensure bpp of video mode is 32 bit
f993a230 Fix overlapping memory bug and sizeof cmdline bug
573b3308 Add KERNEL_DRIVE default value
1cbd6fb2 Plug in e820 driver
f537f64b Add e820 driver
c0129c4d Fix pagemap bug
1166de64 Add initial VBE driver
26bccc63 Add RSDP detection to stivale
0040b97f Working on stivale
80ad7466 Fix section loading function
ee8e1b33 Add function to load elf sections by name
8494b1d8 Add protos abstraction and stivale and qword protocols
c66d052a Map 4GiB of phys memory at 0xffff800000000000
1b80c8ca Misc stuff
f762a0c7 elf: Remove stupid code
85709a0f elf: Add support for higher half kernels
d95a8403 Use elf64
1a48bec6 Add elf parser
5c36fac3 Add testing facilities
225a7c23 echfs: Add open and read functions
1ce2a8d3 Bump gcc and binutils versions in make_toolchain.sh
ab5b09e2 Add editing capabilities to gets
a9b31d6b Add command line editor
2f4311b2 Disable interrupts before jumping to kernel
cddacc28 Add IDT and PIT driver
9b5c159d Improve disk driver
42325aed Add config file parsing
48ce450a Fix gets bug
5082a450 Clean up more and add getchar and gets
fdfc83ab Clean bootsect code up
54074f2a Bug fixes in echfs driver, add 64 bit integer print formats
85d61520 Further work in echfs and partition management
9339c093 Fix libgcc linkage issue
f7b0f240 Add make toolchain script and reorganise source tree
d624a354 Add a .bss section to linker script
97258c43 Added install script
52125cd0 Add MBR parsing
59ea2f0b Increased size to 32 KiB
991487c2 Merge pull request #4 from sakuranakamoto/master
44cb46a1 Revert "Removed save GPR code in read_sector"
c7972236 Removed save GPR code in read_sector
3b44ce6f Made error messages more specific
859b767b Misc fixes to disk driver and real mode ints
33ce2639 Merge pull request #3 from iiSaLMaN/disk-cached-read
304819ce some slight updates
e34646ba Add cached read function + some slight updates
3768a8cf Other small changes to disk driver
bbfc5d36 Adjustments to disk driver
fc6c21ec Moved disk stuff to the right place
7506fcb8 Add simple disk library (#2)
77572b0d Added print
3645ec0b Added libc.h
d1a4f785 Added rm_int function to execute real mode interrupts from pmode
6d533452 Added license
3de2394f Make stage 3 32 bit
563825e4 Enable A20 line and enter 'unreal mode' in the bootsect
3c4c1a87 Add separate bootsector and stage2, add VGA text mode driver
27692884 Initial commit
cd38e248 Initial commit
